// Compiled by ClojureScript 1.10.439 {}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
goog.require('goog.array');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__2997 = arguments.length;
switch (G__2997) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async2998 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async2998 = (function (f,blockable,meta2999){
this.f = f;
this.blockable = blockable;
this.meta2999 = meta2999;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_3000,meta2999__$1){
var self__ = this;
var _3000__$1 = this;
return (new cljs.core.async.t_cljs$core$async2998(self__.f,self__.blockable,meta2999__$1));
});

cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_3000){
var self__ = this;
var _3000__$1 = this;
return self__.meta2999;
});

cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async2998.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async2998.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta2999","meta2999",-165890529,null)], null);
});

cljs.core.async.t_cljs$core$async2998.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async2998.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async2998";

cljs.core.async.t_cljs$core$async2998.cljs$lang$ctorPrWriter = (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async2998");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async2998.
 */
cljs.core.async.__GT_t_cljs$core$async2998 = (function cljs$core$async$__GT_t_cljs$core$async2998(f__$1,blockable__$1,meta2999){
return (new cljs.core.async.t_cljs$core$async2998(f__$1,blockable__$1,meta2999));
});

}

return (new cljs.core.async.t_cljs$core$async2998(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__3004 = arguments.length;
switch (G__3004) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__3007 = arguments.length;
switch (G__3007) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__3010 = arguments.length;
switch (G__3010) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_3012 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_3012);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_3012,ret){
return (function (){
return fn1.call(null,val_3012);
});})(val_3012,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__3014 = arguments.length;
switch (G__3014) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5733__auto__)){
var ret = temp__5733__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__5733__auto__)){
var retb = temp__5733__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__5733__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__5733__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4518__auto___3016 = n;
var x_3017 = (0);
while(true){
if((x_3017 < n__4518__auto___3016)){
(a[x_3017] = x_3017);

var G__3018 = (x_3017 + (1));
x_3017 = G__3018;
continue;
} else {
}
break;
}

goog.array.shuffle(a);

return a;
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async3019 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3019 = (function (flag,meta3020){
this.flag = flag;
this.meta3020 = meta3020;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_3021,meta3020__$1){
var self__ = this;
var _3021__$1 = this;
return (new cljs.core.async.t_cljs$core$async3019(self__.flag,meta3020__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_3021){
var self__ = this;
var _3021__$1 = this;
return self__.meta3020;
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta3020","meta3020",1223330919,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async3019.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3019.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3019";

cljs.core.async.t_cljs$core$async3019.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async3019");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3019.
 */
cljs.core.async.__GT_t_cljs$core$async3019 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async3019(flag__$1,meta3020){
return (new cljs.core.async.t_cljs$core$async3019(flag__$1,meta3020));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async3019(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async3022 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3022 = (function (flag,cb,meta3023){
this.flag = flag;
this.cb = cb;
this.meta3023 = meta3023;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_3024,meta3023__$1){
var self__ = this;
var _3024__$1 = this;
return (new cljs.core.async.t_cljs$core$async3022(self__.flag,self__.cb,meta3023__$1));
});

cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_3024){
var self__ = this;
var _3024__$1 = this;
return self__.meta3023;
});

cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async3022.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async3022.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta3023","meta3023",74943153,null)], null);
});

cljs.core.async.t_cljs$core$async3022.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3022.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3022";

cljs.core.async.t_cljs$core$async3022.cljs$lang$ctorPrWriter = (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async3022");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3022.
 */
cljs.core.async.__GT_t_cljs$core$async3022 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async3022(flag__$1,cb__$1,meta3023){
return (new cljs.core.async.t_cljs$core$async3022(flag__$1,cb__$1,meta3023));
});

}

return (new cljs.core.async.t_cljs$core$async3022(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
if((cljs.core.count.call(null,ports) > (0))){
} else {
throw (new Error(["Assert failed: ","alts must have at least one channel operation","\n","(pos? (count ports))"].join('')));
}

var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__3025_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__3025_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__3026_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__3026_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__4047__auto__ = wport;
if(cljs.core.truth_(or__4047__auto__)){
return or__4047__auto__;
} else {
return port;
}
})()], null));
} else {
var G__3027 = (i + (1));
i = G__3027;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4047__auto__ = ret;
if(cljs.core.truth_(or__4047__auto__)){
return or__4047__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5735__auto__ = (function (){var and__4036__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__4036__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__4036__auto__;
}
})();
if(cljs.core.truth_(temp__5735__auto__)){
var got = temp__5735__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4647__auto__ = [];
var len__4641__auto___3033 = arguments.length;
var i__4642__auto___3034 = (0);
while(true){
if((i__4642__auto___3034 < len__4641__auto___3033)){
args__4647__auto__.push((arguments[i__4642__auto___3034]));

var G__3035 = (i__4642__auto___3034 + (1));
i__4642__auto___3034 = G__3035;
continue;
} else {
}
break;
}

var argseq__4648__auto__ = ((((1) < args__4647__auto__.length))?(new cljs.core.IndexedSeq(args__4647__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4648__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__3030){
var map__3031 = p__3030;
var map__3031__$1 = (((((!((map__3031 == null))))?(((((map__3031.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__3031.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__3031):map__3031);
var opts = map__3031__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq3028){
var G__3029 = cljs.core.first.call(null,seq3028);
var seq3028__$1 = cljs.core.next.call(null,seq3028);
var self__4628__auto__ = this;
return self__4628__auto__.cljs$core$IFn$_invoke$arity$variadic(G__3029,seq3028__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__3037 = arguments.length;
switch (G__3037) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__2937__auto___3083 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3083){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3083){
return (function (state_3061){
var state_val_3062 = (state_3061[(1)]);
if((state_val_3062 === (7))){
var inst_3057 = (state_3061[(2)]);
var state_3061__$1 = state_3061;
var statearr_3063_3084 = state_3061__$1;
(statearr_3063_3084[(2)] = inst_3057);

(statearr_3063_3084[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (1))){
var state_3061__$1 = state_3061;
var statearr_3064_3085 = state_3061__$1;
(statearr_3064_3085[(2)] = null);

(statearr_3064_3085[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (4))){
var inst_3040 = (state_3061[(7)]);
var inst_3040__$1 = (state_3061[(2)]);
var inst_3041 = (inst_3040__$1 == null);
var state_3061__$1 = (function (){var statearr_3065 = state_3061;
(statearr_3065[(7)] = inst_3040__$1);

return statearr_3065;
})();
if(cljs.core.truth_(inst_3041)){
var statearr_3066_3086 = state_3061__$1;
(statearr_3066_3086[(1)] = (5));

} else {
var statearr_3067_3087 = state_3061__$1;
(statearr_3067_3087[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (13))){
var state_3061__$1 = state_3061;
var statearr_3068_3088 = state_3061__$1;
(statearr_3068_3088[(2)] = null);

(statearr_3068_3088[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (6))){
var inst_3040 = (state_3061[(7)]);
var state_3061__$1 = state_3061;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3061__$1,(11),to,inst_3040);
} else {
if((state_val_3062 === (3))){
var inst_3059 = (state_3061[(2)]);
var state_3061__$1 = state_3061;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3061__$1,inst_3059);
} else {
if((state_val_3062 === (12))){
var state_3061__$1 = state_3061;
var statearr_3069_3089 = state_3061__$1;
(statearr_3069_3089[(2)] = null);

(statearr_3069_3089[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (2))){
var state_3061__$1 = state_3061;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3061__$1,(4),from);
} else {
if((state_val_3062 === (11))){
var inst_3050 = (state_3061[(2)]);
var state_3061__$1 = state_3061;
if(cljs.core.truth_(inst_3050)){
var statearr_3070_3090 = state_3061__$1;
(statearr_3070_3090[(1)] = (12));

} else {
var statearr_3071_3091 = state_3061__$1;
(statearr_3071_3091[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (9))){
var state_3061__$1 = state_3061;
var statearr_3072_3092 = state_3061__$1;
(statearr_3072_3092[(2)] = null);

(statearr_3072_3092[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (5))){
var state_3061__$1 = state_3061;
if(cljs.core.truth_(close_QMARK_)){
var statearr_3073_3093 = state_3061__$1;
(statearr_3073_3093[(1)] = (8));

} else {
var statearr_3074_3094 = state_3061__$1;
(statearr_3074_3094[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (14))){
var inst_3055 = (state_3061[(2)]);
var state_3061__$1 = state_3061;
var statearr_3075_3095 = state_3061__$1;
(statearr_3075_3095[(2)] = inst_3055);

(statearr_3075_3095[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (10))){
var inst_3047 = (state_3061[(2)]);
var state_3061__$1 = state_3061;
var statearr_3076_3096 = state_3061__$1;
(statearr_3076_3096[(2)] = inst_3047);

(statearr_3076_3096[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3062 === (8))){
var inst_3044 = cljs.core.async.close_BANG_.call(null,to);
var state_3061__$1 = state_3061;
var statearr_3077_3097 = state_3061__$1;
(statearr_3077_3097[(2)] = inst_3044);

(statearr_3077_3097[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___3083))
;
return ((function (switch__2842__auto__,c__2937__auto___3083){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_3078 = [null,null,null,null,null,null,null,null];
(statearr_3078[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_3078[(1)] = (1));

return statearr_3078;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_3061){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3061);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3079){if((e3079 instanceof Object)){
var ex__2846__auto__ = e3079;
var statearr_3080_3098 = state_3061;
(statearr_3080_3098[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3061);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3079;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3099 = state_3061;
state_3061 = G__3099;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_3061){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_3061);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3083))
})();
var state__2939__auto__ = (function (){var statearr_3081 = f__2938__auto__.call(null);
(statearr_3081[(6)] = c__2937__auto___3083);

return statearr_3081;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3083))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__3100){
var vec__3101 = p__3100;
var v = cljs.core.nth.call(null,vec__3101,(0),null);
var p = cljs.core.nth.call(null,vec__3101,(1),null);
var job = vec__3101;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__2937__auto___3272 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results){
return (function (state_3108){
var state_val_3109 = (state_3108[(1)]);
if((state_val_3109 === (1))){
var state_3108__$1 = state_3108;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3108__$1,(2),res,v);
} else {
if((state_val_3109 === (2))){
var inst_3105 = (state_3108[(2)]);
var inst_3106 = cljs.core.async.close_BANG_.call(null,res);
var state_3108__$1 = (function (){var statearr_3110 = state_3108;
(statearr_3110[(7)] = inst_3105);

return statearr_3110;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3108__$1,inst_3106);
} else {
return null;
}
}
});})(c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results))
;
return ((function (switch__2842__auto__,c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_3111 = [null,null,null,null,null,null,null,null];
(statearr_3111[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__);

(statearr_3111[(1)] = (1));

return statearr_3111;
});
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1 = (function (state_3108){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3108);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3112){if((e3112 instanceof Object)){
var ex__2846__auto__ = e3112;
var statearr_3113_3273 = state_3108;
(statearr_3113_3273[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3108);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3112;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3274 = state_3108;
state_3108 = G__3274;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = function(state_3108){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1.call(this,state_3108);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results))
})();
var state__2939__auto__ = (function (){var statearr_3114 = f__2938__auto__.call(null);
(statearr_3114[(6)] = c__2937__auto___3272);

return statearr_3114;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3272,res,vec__3101,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__3115){
var vec__3116 = p__3115;
var v = cljs.core.nth.call(null,vec__3116,(0),null);
var p = cljs.core.nth.call(null,vec__3116,(1),null);
var job = vec__3116;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__4518__auto___3275 = n;
var __3276 = (0);
while(true){
if((__3276 < n__4518__auto___3275)){
var G__3119_3277 = type;
var G__3119_3278__$1 = (((G__3119_3277 instanceof cljs.core.Keyword))?G__3119_3277.fqn:null);
switch (G__3119_3278__$1) {
case "compute":
var c__2937__auto___3280 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__3276,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (__3276,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function (state_3132){
var state_val_3133 = (state_3132[(1)]);
if((state_val_3133 === (1))){
var state_3132__$1 = state_3132;
var statearr_3134_3281 = state_3132__$1;
(statearr_3134_3281[(2)] = null);

(statearr_3134_3281[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3133 === (2))){
var state_3132__$1 = state_3132;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3132__$1,(4),jobs);
} else {
if((state_val_3133 === (3))){
var inst_3130 = (state_3132[(2)]);
var state_3132__$1 = state_3132;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3132__$1,inst_3130);
} else {
if((state_val_3133 === (4))){
var inst_3122 = (state_3132[(2)]);
var inst_3123 = process.call(null,inst_3122);
var state_3132__$1 = state_3132;
if(cljs.core.truth_(inst_3123)){
var statearr_3135_3282 = state_3132__$1;
(statearr_3135_3282[(1)] = (5));

} else {
var statearr_3136_3283 = state_3132__$1;
(statearr_3136_3283[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3133 === (5))){
var state_3132__$1 = state_3132;
var statearr_3137_3284 = state_3132__$1;
(statearr_3137_3284[(2)] = null);

(statearr_3137_3284[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3133 === (6))){
var state_3132__$1 = state_3132;
var statearr_3138_3285 = state_3132__$1;
(statearr_3138_3285[(2)] = null);

(statearr_3138_3285[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3133 === (7))){
var inst_3128 = (state_3132[(2)]);
var state_3132__$1 = state_3132;
var statearr_3139_3286 = state_3132__$1;
(statearr_3139_3286[(2)] = inst_3128);

(statearr_3139_3286[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__3276,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
;
return ((function (__3276,switch__2842__auto__,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_3140 = [null,null,null,null,null,null,null];
(statearr_3140[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__);

(statearr_3140[(1)] = (1));

return statearr_3140;
});
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1 = (function (state_3132){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3132);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3141){if((e3141 instanceof Object)){
var ex__2846__auto__ = e3141;
var statearr_3142_3287 = state_3132;
(statearr_3142_3287[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3132);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3141;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3288 = state_3132;
state_3132 = G__3288;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = function(state_3132){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1.call(this,state_3132);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__;
})()
;})(__3276,switch__2842__auto__,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
})();
var state__2939__auto__ = (function (){var statearr_3143 = f__2938__auto__.call(null);
(statearr_3143[(6)] = c__2937__auto___3280);

return statearr_3143;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(__3276,c__2937__auto___3280,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
);


break;
case "async":
var c__2937__auto___3289 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__3276,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (__3276,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function (state_3156){
var state_val_3157 = (state_3156[(1)]);
if((state_val_3157 === (1))){
var state_3156__$1 = state_3156;
var statearr_3158_3290 = state_3156__$1;
(statearr_3158_3290[(2)] = null);

(statearr_3158_3290[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3157 === (2))){
var state_3156__$1 = state_3156;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3156__$1,(4),jobs);
} else {
if((state_val_3157 === (3))){
var inst_3154 = (state_3156[(2)]);
var state_3156__$1 = state_3156;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3156__$1,inst_3154);
} else {
if((state_val_3157 === (4))){
var inst_3146 = (state_3156[(2)]);
var inst_3147 = async.call(null,inst_3146);
var state_3156__$1 = state_3156;
if(cljs.core.truth_(inst_3147)){
var statearr_3159_3291 = state_3156__$1;
(statearr_3159_3291[(1)] = (5));

} else {
var statearr_3160_3292 = state_3156__$1;
(statearr_3160_3292[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3157 === (5))){
var state_3156__$1 = state_3156;
var statearr_3161_3293 = state_3156__$1;
(statearr_3161_3293[(2)] = null);

(statearr_3161_3293[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3157 === (6))){
var state_3156__$1 = state_3156;
var statearr_3162_3294 = state_3156__$1;
(statearr_3162_3294[(2)] = null);

(statearr_3162_3294[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3157 === (7))){
var inst_3152 = (state_3156[(2)]);
var state_3156__$1 = state_3156;
var statearr_3163_3295 = state_3156__$1;
(statearr_3163_3295[(2)] = inst_3152);

(statearr_3163_3295[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__3276,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
;
return ((function (__3276,switch__2842__auto__,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_3164 = [null,null,null,null,null,null,null];
(statearr_3164[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__);

(statearr_3164[(1)] = (1));

return statearr_3164;
});
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1 = (function (state_3156){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3156);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3165){if((e3165 instanceof Object)){
var ex__2846__auto__ = e3165;
var statearr_3166_3296 = state_3156;
(statearr_3166_3296[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3156);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3165;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3297 = state_3156;
state_3156 = G__3297;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = function(state_3156){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1.call(this,state_3156);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__;
})()
;})(__3276,switch__2842__auto__,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
})();
var state__2939__auto__ = (function (){var statearr_3167 = f__2938__auto__.call(null);
(statearr_3167[(6)] = c__2937__auto___3289);

return statearr_3167;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(__3276,c__2937__auto___3289,G__3119_3277,G__3119_3278__$1,n__4518__auto___3275,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__3119_3278__$1)].join('')));

}

var G__3298 = (__3276 + (1));
__3276 = G__3298;
continue;
} else {
}
break;
}

var c__2937__auto___3299 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3299,jobs,results,process,async){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3299,jobs,results,process,async){
return (function (state_3189){
var state_val_3190 = (state_3189[(1)]);
if((state_val_3190 === (7))){
var inst_3185 = (state_3189[(2)]);
var state_3189__$1 = state_3189;
var statearr_3191_3300 = state_3189__$1;
(statearr_3191_3300[(2)] = inst_3185);

(statearr_3191_3300[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3190 === (1))){
var state_3189__$1 = state_3189;
var statearr_3192_3301 = state_3189__$1;
(statearr_3192_3301[(2)] = null);

(statearr_3192_3301[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3190 === (4))){
var inst_3170 = (state_3189[(7)]);
var inst_3170__$1 = (state_3189[(2)]);
var inst_3171 = (inst_3170__$1 == null);
var state_3189__$1 = (function (){var statearr_3193 = state_3189;
(statearr_3193[(7)] = inst_3170__$1);

return statearr_3193;
})();
if(cljs.core.truth_(inst_3171)){
var statearr_3194_3302 = state_3189__$1;
(statearr_3194_3302[(1)] = (5));

} else {
var statearr_3195_3303 = state_3189__$1;
(statearr_3195_3303[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3190 === (6))){
var inst_3175 = (state_3189[(8)]);
var inst_3170 = (state_3189[(7)]);
var inst_3175__$1 = cljs.core.async.chan.call(null,(1));
var inst_3176 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_3177 = [inst_3170,inst_3175__$1];
var inst_3178 = (new cljs.core.PersistentVector(null,2,(5),inst_3176,inst_3177,null));
var state_3189__$1 = (function (){var statearr_3196 = state_3189;
(statearr_3196[(8)] = inst_3175__$1);

return statearr_3196;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3189__$1,(8),jobs,inst_3178);
} else {
if((state_val_3190 === (3))){
var inst_3187 = (state_3189[(2)]);
var state_3189__$1 = state_3189;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3189__$1,inst_3187);
} else {
if((state_val_3190 === (2))){
var state_3189__$1 = state_3189;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3189__$1,(4),from);
} else {
if((state_val_3190 === (9))){
var inst_3182 = (state_3189[(2)]);
var state_3189__$1 = (function (){var statearr_3197 = state_3189;
(statearr_3197[(9)] = inst_3182);

return statearr_3197;
})();
var statearr_3198_3304 = state_3189__$1;
(statearr_3198_3304[(2)] = null);

(statearr_3198_3304[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3190 === (5))){
var inst_3173 = cljs.core.async.close_BANG_.call(null,jobs);
var state_3189__$1 = state_3189;
var statearr_3199_3305 = state_3189__$1;
(statearr_3199_3305[(2)] = inst_3173);

(statearr_3199_3305[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3190 === (8))){
var inst_3175 = (state_3189[(8)]);
var inst_3180 = (state_3189[(2)]);
var state_3189__$1 = (function (){var statearr_3200 = state_3189;
(statearr_3200[(10)] = inst_3180);

return statearr_3200;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3189__$1,(9),results,inst_3175);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___3299,jobs,results,process,async))
;
return ((function (switch__2842__auto__,c__2937__auto___3299,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_3201 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_3201[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__);

(statearr_3201[(1)] = (1));

return statearr_3201;
});
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1 = (function (state_3189){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3189);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3202){if((e3202 instanceof Object)){
var ex__2846__auto__ = e3202;
var statearr_3203_3306 = state_3189;
(statearr_3203_3306[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3189);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3202;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3307 = state_3189;
state_3189 = G__3307;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = function(state_3189){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1.call(this,state_3189);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3299,jobs,results,process,async))
})();
var state__2939__auto__ = (function (){var statearr_3204 = f__2938__auto__.call(null);
(statearr_3204[(6)] = c__2937__auto___3299);

return statearr_3204;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3299,jobs,results,process,async))
);


var c__2937__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto__,jobs,results,process,async){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto__,jobs,results,process,async){
return (function (state_3242){
var state_val_3243 = (state_3242[(1)]);
if((state_val_3243 === (7))){
var inst_3238 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
var statearr_3244_3308 = state_3242__$1;
(statearr_3244_3308[(2)] = inst_3238);

(statearr_3244_3308[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (20))){
var state_3242__$1 = state_3242;
var statearr_3245_3309 = state_3242__$1;
(statearr_3245_3309[(2)] = null);

(statearr_3245_3309[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (1))){
var state_3242__$1 = state_3242;
var statearr_3246_3310 = state_3242__$1;
(statearr_3246_3310[(2)] = null);

(statearr_3246_3310[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (4))){
var inst_3207 = (state_3242[(7)]);
var inst_3207__$1 = (state_3242[(2)]);
var inst_3208 = (inst_3207__$1 == null);
var state_3242__$1 = (function (){var statearr_3247 = state_3242;
(statearr_3247[(7)] = inst_3207__$1);

return statearr_3247;
})();
if(cljs.core.truth_(inst_3208)){
var statearr_3248_3311 = state_3242__$1;
(statearr_3248_3311[(1)] = (5));

} else {
var statearr_3249_3312 = state_3242__$1;
(statearr_3249_3312[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (15))){
var inst_3220 = (state_3242[(8)]);
var state_3242__$1 = state_3242;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3242__$1,(18),to,inst_3220);
} else {
if((state_val_3243 === (21))){
var inst_3233 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
var statearr_3250_3313 = state_3242__$1;
(statearr_3250_3313[(2)] = inst_3233);

(statearr_3250_3313[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (13))){
var inst_3235 = (state_3242[(2)]);
var state_3242__$1 = (function (){var statearr_3251 = state_3242;
(statearr_3251[(9)] = inst_3235);

return statearr_3251;
})();
var statearr_3252_3314 = state_3242__$1;
(statearr_3252_3314[(2)] = null);

(statearr_3252_3314[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (6))){
var inst_3207 = (state_3242[(7)]);
var state_3242__$1 = state_3242;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3242__$1,(11),inst_3207);
} else {
if((state_val_3243 === (17))){
var inst_3228 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
if(cljs.core.truth_(inst_3228)){
var statearr_3253_3315 = state_3242__$1;
(statearr_3253_3315[(1)] = (19));

} else {
var statearr_3254_3316 = state_3242__$1;
(statearr_3254_3316[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (3))){
var inst_3240 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3242__$1,inst_3240);
} else {
if((state_val_3243 === (12))){
var inst_3217 = (state_3242[(10)]);
var state_3242__$1 = state_3242;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3242__$1,(14),inst_3217);
} else {
if((state_val_3243 === (2))){
var state_3242__$1 = state_3242;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3242__$1,(4),results);
} else {
if((state_val_3243 === (19))){
var state_3242__$1 = state_3242;
var statearr_3255_3317 = state_3242__$1;
(statearr_3255_3317[(2)] = null);

(statearr_3255_3317[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (11))){
var inst_3217 = (state_3242[(2)]);
var state_3242__$1 = (function (){var statearr_3256 = state_3242;
(statearr_3256[(10)] = inst_3217);

return statearr_3256;
})();
var statearr_3257_3318 = state_3242__$1;
(statearr_3257_3318[(2)] = null);

(statearr_3257_3318[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (9))){
var state_3242__$1 = state_3242;
var statearr_3258_3319 = state_3242__$1;
(statearr_3258_3319[(2)] = null);

(statearr_3258_3319[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (5))){
var state_3242__$1 = state_3242;
if(cljs.core.truth_(close_QMARK_)){
var statearr_3259_3320 = state_3242__$1;
(statearr_3259_3320[(1)] = (8));

} else {
var statearr_3260_3321 = state_3242__$1;
(statearr_3260_3321[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (14))){
var inst_3220 = (state_3242[(8)]);
var inst_3222 = (state_3242[(11)]);
var inst_3220__$1 = (state_3242[(2)]);
var inst_3221 = (inst_3220__$1 == null);
var inst_3222__$1 = cljs.core.not.call(null,inst_3221);
var state_3242__$1 = (function (){var statearr_3261 = state_3242;
(statearr_3261[(8)] = inst_3220__$1);

(statearr_3261[(11)] = inst_3222__$1);

return statearr_3261;
})();
if(inst_3222__$1){
var statearr_3262_3322 = state_3242__$1;
(statearr_3262_3322[(1)] = (15));

} else {
var statearr_3263_3323 = state_3242__$1;
(statearr_3263_3323[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (16))){
var inst_3222 = (state_3242[(11)]);
var state_3242__$1 = state_3242;
var statearr_3264_3324 = state_3242__$1;
(statearr_3264_3324[(2)] = inst_3222);

(statearr_3264_3324[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (10))){
var inst_3214 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
var statearr_3265_3325 = state_3242__$1;
(statearr_3265_3325[(2)] = inst_3214);

(statearr_3265_3325[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (18))){
var inst_3225 = (state_3242[(2)]);
var state_3242__$1 = state_3242;
var statearr_3266_3326 = state_3242__$1;
(statearr_3266_3326[(2)] = inst_3225);

(statearr_3266_3326[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3243 === (8))){
var inst_3211 = cljs.core.async.close_BANG_.call(null,to);
var state_3242__$1 = state_3242;
var statearr_3267_3327 = state_3242__$1;
(statearr_3267_3327[(2)] = inst_3211);

(statearr_3267_3327[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto__,jobs,results,process,async))
;
return ((function (switch__2842__auto__,c__2937__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_3268 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_3268[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__);

(statearr_3268[(1)] = (1));

return statearr_3268;
});
var cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1 = (function (state_3242){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3242);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3269){if((e3269 instanceof Object)){
var ex__2846__auto__ = e3269;
var statearr_3270_3328 = state_3242;
(statearr_3270_3328[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3242);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3269;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3329 = state_3242;
state_3242 = G__3329;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__ = function(state_3242){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1.call(this,state_3242);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto__,jobs,results,process,async))
})();
var state__2939__auto__ = (function (){var statearr_3271 = f__2938__auto__.call(null);
(statearr_3271[(6)] = c__2937__auto__);

return statearr_3271;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto__,jobs,results,process,async))
);

return c__2937__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__3331 = arguments.length;
switch (G__3331) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__3334 = arguments.length;
switch (G__3334) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__3337 = arguments.length;
switch (G__3337) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__2937__auto___3386 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3386,tc,fc){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3386,tc,fc){
return (function (state_3363){
var state_val_3364 = (state_3363[(1)]);
if((state_val_3364 === (7))){
var inst_3359 = (state_3363[(2)]);
var state_3363__$1 = state_3363;
var statearr_3365_3387 = state_3363__$1;
(statearr_3365_3387[(2)] = inst_3359);

(statearr_3365_3387[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (1))){
var state_3363__$1 = state_3363;
var statearr_3366_3388 = state_3363__$1;
(statearr_3366_3388[(2)] = null);

(statearr_3366_3388[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (4))){
var inst_3340 = (state_3363[(7)]);
var inst_3340__$1 = (state_3363[(2)]);
var inst_3341 = (inst_3340__$1 == null);
var state_3363__$1 = (function (){var statearr_3367 = state_3363;
(statearr_3367[(7)] = inst_3340__$1);

return statearr_3367;
})();
if(cljs.core.truth_(inst_3341)){
var statearr_3368_3389 = state_3363__$1;
(statearr_3368_3389[(1)] = (5));

} else {
var statearr_3369_3390 = state_3363__$1;
(statearr_3369_3390[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (13))){
var state_3363__$1 = state_3363;
var statearr_3370_3391 = state_3363__$1;
(statearr_3370_3391[(2)] = null);

(statearr_3370_3391[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (6))){
var inst_3340 = (state_3363[(7)]);
var inst_3346 = p.call(null,inst_3340);
var state_3363__$1 = state_3363;
if(cljs.core.truth_(inst_3346)){
var statearr_3371_3392 = state_3363__$1;
(statearr_3371_3392[(1)] = (9));

} else {
var statearr_3372_3393 = state_3363__$1;
(statearr_3372_3393[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (3))){
var inst_3361 = (state_3363[(2)]);
var state_3363__$1 = state_3363;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3363__$1,inst_3361);
} else {
if((state_val_3364 === (12))){
var state_3363__$1 = state_3363;
var statearr_3373_3394 = state_3363__$1;
(statearr_3373_3394[(2)] = null);

(statearr_3373_3394[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (2))){
var state_3363__$1 = state_3363;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3363__$1,(4),ch);
} else {
if((state_val_3364 === (11))){
var inst_3340 = (state_3363[(7)]);
var inst_3350 = (state_3363[(2)]);
var state_3363__$1 = state_3363;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3363__$1,(8),inst_3350,inst_3340);
} else {
if((state_val_3364 === (9))){
var state_3363__$1 = state_3363;
var statearr_3374_3395 = state_3363__$1;
(statearr_3374_3395[(2)] = tc);

(statearr_3374_3395[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (5))){
var inst_3343 = cljs.core.async.close_BANG_.call(null,tc);
var inst_3344 = cljs.core.async.close_BANG_.call(null,fc);
var state_3363__$1 = (function (){var statearr_3375 = state_3363;
(statearr_3375[(8)] = inst_3343);

return statearr_3375;
})();
var statearr_3376_3396 = state_3363__$1;
(statearr_3376_3396[(2)] = inst_3344);

(statearr_3376_3396[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (14))){
var inst_3357 = (state_3363[(2)]);
var state_3363__$1 = state_3363;
var statearr_3377_3397 = state_3363__$1;
(statearr_3377_3397[(2)] = inst_3357);

(statearr_3377_3397[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (10))){
var state_3363__$1 = state_3363;
var statearr_3378_3398 = state_3363__$1;
(statearr_3378_3398[(2)] = fc);

(statearr_3378_3398[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3364 === (8))){
var inst_3352 = (state_3363[(2)]);
var state_3363__$1 = state_3363;
if(cljs.core.truth_(inst_3352)){
var statearr_3379_3399 = state_3363__$1;
(statearr_3379_3399[(1)] = (12));

} else {
var statearr_3380_3400 = state_3363__$1;
(statearr_3380_3400[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___3386,tc,fc))
;
return ((function (switch__2842__auto__,c__2937__auto___3386,tc,fc){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_3381 = [null,null,null,null,null,null,null,null,null];
(statearr_3381[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_3381[(1)] = (1));

return statearr_3381;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_3363){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3363);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3382){if((e3382 instanceof Object)){
var ex__2846__auto__ = e3382;
var statearr_3383_3401 = state_3363;
(statearr_3383_3401[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3363);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3382;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3402 = state_3363;
state_3363 = G__3402;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_3363){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_3363);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3386,tc,fc))
})();
var state__2939__auto__ = (function (){var statearr_3384 = f__2938__auto__.call(null);
(statearr_3384[(6)] = c__2937__auto___3386);

return statearr_3384;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3386,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__2937__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto__){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto__){
return (function (state_3423){
var state_val_3424 = (state_3423[(1)]);
if((state_val_3424 === (7))){
var inst_3419 = (state_3423[(2)]);
var state_3423__$1 = state_3423;
var statearr_3425_3443 = state_3423__$1;
(statearr_3425_3443[(2)] = inst_3419);

(statearr_3425_3443[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (1))){
var inst_3403 = init;
var state_3423__$1 = (function (){var statearr_3426 = state_3423;
(statearr_3426[(7)] = inst_3403);

return statearr_3426;
})();
var statearr_3427_3444 = state_3423__$1;
(statearr_3427_3444[(2)] = null);

(statearr_3427_3444[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (4))){
var inst_3406 = (state_3423[(8)]);
var inst_3406__$1 = (state_3423[(2)]);
var inst_3407 = (inst_3406__$1 == null);
var state_3423__$1 = (function (){var statearr_3428 = state_3423;
(statearr_3428[(8)] = inst_3406__$1);

return statearr_3428;
})();
if(cljs.core.truth_(inst_3407)){
var statearr_3429_3445 = state_3423__$1;
(statearr_3429_3445[(1)] = (5));

} else {
var statearr_3430_3446 = state_3423__$1;
(statearr_3430_3446[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (6))){
var inst_3406 = (state_3423[(8)]);
var inst_3410 = (state_3423[(9)]);
var inst_3403 = (state_3423[(7)]);
var inst_3410__$1 = f.call(null,inst_3403,inst_3406);
var inst_3411 = cljs.core.reduced_QMARK_.call(null,inst_3410__$1);
var state_3423__$1 = (function (){var statearr_3431 = state_3423;
(statearr_3431[(9)] = inst_3410__$1);

return statearr_3431;
})();
if(inst_3411){
var statearr_3432_3447 = state_3423__$1;
(statearr_3432_3447[(1)] = (8));

} else {
var statearr_3433_3448 = state_3423__$1;
(statearr_3433_3448[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (3))){
var inst_3421 = (state_3423[(2)]);
var state_3423__$1 = state_3423;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3423__$1,inst_3421);
} else {
if((state_val_3424 === (2))){
var state_3423__$1 = state_3423;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3423__$1,(4),ch);
} else {
if((state_val_3424 === (9))){
var inst_3410 = (state_3423[(9)]);
var inst_3403 = inst_3410;
var state_3423__$1 = (function (){var statearr_3434 = state_3423;
(statearr_3434[(7)] = inst_3403);

return statearr_3434;
})();
var statearr_3435_3449 = state_3423__$1;
(statearr_3435_3449[(2)] = null);

(statearr_3435_3449[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (5))){
var inst_3403 = (state_3423[(7)]);
var state_3423__$1 = state_3423;
var statearr_3436_3450 = state_3423__$1;
(statearr_3436_3450[(2)] = inst_3403);

(statearr_3436_3450[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (10))){
var inst_3417 = (state_3423[(2)]);
var state_3423__$1 = state_3423;
var statearr_3437_3451 = state_3423__$1;
(statearr_3437_3451[(2)] = inst_3417);

(statearr_3437_3451[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3424 === (8))){
var inst_3410 = (state_3423[(9)]);
var inst_3413 = cljs.core.deref.call(null,inst_3410);
var state_3423__$1 = state_3423;
var statearr_3438_3452 = state_3423__$1;
(statearr_3438_3452[(2)] = inst_3413);

(statearr_3438_3452[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto__))
;
return ((function (switch__2842__auto__,c__2937__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__2843__auto__ = null;
var cljs$core$async$reduce_$_state_machine__2843__auto____0 = (function (){
var statearr_3439 = [null,null,null,null,null,null,null,null,null,null];
(statearr_3439[(0)] = cljs$core$async$reduce_$_state_machine__2843__auto__);

(statearr_3439[(1)] = (1));

return statearr_3439;
});
var cljs$core$async$reduce_$_state_machine__2843__auto____1 = (function (state_3423){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3423);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3440){if((e3440 instanceof Object)){
var ex__2846__auto__ = e3440;
var statearr_3441_3453 = state_3423;
(statearr_3441_3453[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3423);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3440;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3454 = state_3423;
state_3423 = G__3454;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__2843__auto__ = function(state_3423){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__2843__auto____1.call(this,state_3423);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__2843__auto____0;
cljs$core$async$reduce_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__2843__auto____1;
return cljs$core$async$reduce_$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto__))
})();
var state__2939__auto__ = (function (){var statearr_3442 = f__2938__auto__.call(null);
(statearr_3442[(6)] = c__2937__auto__);

return statearr_3442;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto__))
);

return c__2937__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__2937__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto__,f__$1){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto__,f__$1){
return (function (state_3460){
var state_val_3461 = (state_3460[(1)]);
if((state_val_3461 === (1))){
var inst_3455 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_3460__$1 = state_3460;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3460__$1,(2),inst_3455);
} else {
if((state_val_3461 === (2))){
var inst_3457 = (state_3460[(2)]);
var inst_3458 = f__$1.call(null,inst_3457);
var state_3460__$1 = state_3460;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3460__$1,inst_3458);
} else {
return null;
}
}
});})(c__2937__auto__,f__$1))
;
return ((function (switch__2842__auto__,c__2937__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__2843__auto__ = null;
var cljs$core$async$transduce_$_state_machine__2843__auto____0 = (function (){
var statearr_3462 = [null,null,null,null,null,null,null];
(statearr_3462[(0)] = cljs$core$async$transduce_$_state_machine__2843__auto__);

(statearr_3462[(1)] = (1));

return statearr_3462;
});
var cljs$core$async$transduce_$_state_machine__2843__auto____1 = (function (state_3460){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3460);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3463){if((e3463 instanceof Object)){
var ex__2846__auto__ = e3463;
var statearr_3464_3466 = state_3460;
(statearr_3464_3466[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3460);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3463;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3467 = state_3460;
state_3460 = G__3467;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__2843__auto__ = function(state_3460){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__2843__auto____1.call(this,state_3460);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__2843__auto____0;
cljs$core$async$transduce_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__2843__auto____1;
return cljs$core$async$transduce_$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto__,f__$1))
})();
var state__2939__auto__ = (function (){var statearr_3465 = f__2938__auto__.call(null);
(statearr_3465[(6)] = c__2937__auto__);

return statearr_3465;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto__,f__$1))
);

return c__2937__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__3469 = arguments.length;
switch (G__3469) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__2937__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto__){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto__){
return (function (state_3494){
var state_val_3495 = (state_3494[(1)]);
if((state_val_3495 === (7))){
var inst_3476 = (state_3494[(2)]);
var state_3494__$1 = state_3494;
var statearr_3496_3517 = state_3494__$1;
(statearr_3496_3517[(2)] = inst_3476);

(statearr_3496_3517[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (1))){
var inst_3470 = cljs.core.seq.call(null,coll);
var inst_3471 = inst_3470;
var state_3494__$1 = (function (){var statearr_3497 = state_3494;
(statearr_3497[(7)] = inst_3471);

return statearr_3497;
})();
var statearr_3498_3518 = state_3494__$1;
(statearr_3498_3518[(2)] = null);

(statearr_3498_3518[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (4))){
var inst_3471 = (state_3494[(7)]);
var inst_3474 = cljs.core.first.call(null,inst_3471);
var state_3494__$1 = state_3494;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3494__$1,(7),ch,inst_3474);
} else {
if((state_val_3495 === (13))){
var inst_3488 = (state_3494[(2)]);
var state_3494__$1 = state_3494;
var statearr_3499_3519 = state_3494__$1;
(statearr_3499_3519[(2)] = inst_3488);

(statearr_3499_3519[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (6))){
var inst_3479 = (state_3494[(2)]);
var state_3494__$1 = state_3494;
if(cljs.core.truth_(inst_3479)){
var statearr_3500_3520 = state_3494__$1;
(statearr_3500_3520[(1)] = (8));

} else {
var statearr_3501_3521 = state_3494__$1;
(statearr_3501_3521[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (3))){
var inst_3492 = (state_3494[(2)]);
var state_3494__$1 = state_3494;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3494__$1,inst_3492);
} else {
if((state_val_3495 === (12))){
var state_3494__$1 = state_3494;
var statearr_3502_3522 = state_3494__$1;
(statearr_3502_3522[(2)] = null);

(statearr_3502_3522[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (2))){
var inst_3471 = (state_3494[(7)]);
var state_3494__$1 = state_3494;
if(cljs.core.truth_(inst_3471)){
var statearr_3503_3523 = state_3494__$1;
(statearr_3503_3523[(1)] = (4));

} else {
var statearr_3504_3524 = state_3494__$1;
(statearr_3504_3524[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (11))){
var inst_3485 = cljs.core.async.close_BANG_.call(null,ch);
var state_3494__$1 = state_3494;
var statearr_3505_3525 = state_3494__$1;
(statearr_3505_3525[(2)] = inst_3485);

(statearr_3505_3525[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (9))){
var state_3494__$1 = state_3494;
if(cljs.core.truth_(close_QMARK_)){
var statearr_3506_3526 = state_3494__$1;
(statearr_3506_3526[(1)] = (11));

} else {
var statearr_3507_3527 = state_3494__$1;
(statearr_3507_3527[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (5))){
var inst_3471 = (state_3494[(7)]);
var state_3494__$1 = state_3494;
var statearr_3508_3528 = state_3494__$1;
(statearr_3508_3528[(2)] = inst_3471);

(statearr_3508_3528[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (10))){
var inst_3490 = (state_3494[(2)]);
var state_3494__$1 = state_3494;
var statearr_3509_3529 = state_3494__$1;
(statearr_3509_3529[(2)] = inst_3490);

(statearr_3509_3529[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3495 === (8))){
var inst_3471 = (state_3494[(7)]);
var inst_3481 = cljs.core.next.call(null,inst_3471);
var inst_3471__$1 = inst_3481;
var state_3494__$1 = (function (){var statearr_3510 = state_3494;
(statearr_3510[(7)] = inst_3471__$1);

return statearr_3510;
})();
var statearr_3511_3530 = state_3494__$1;
(statearr_3511_3530[(2)] = null);

(statearr_3511_3530[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto__))
;
return ((function (switch__2842__auto__,c__2937__auto__){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_3512 = [null,null,null,null,null,null,null,null];
(statearr_3512[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_3512[(1)] = (1));

return statearr_3512;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_3494){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3494);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3513){if((e3513 instanceof Object)){
var ex__2846__auto__ = e3513;
var statearr_3514_3531 = state_3494;
(statearr_3514_3531[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3494);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3513;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3532 = state_3494;
state_3494 = G__3532;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_3494){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_3494);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto__))
})();
var state__2939__auto__ = (function (){var statearr_3515 = f__2938__auto__.call(null);
(statearr_3515[(6)] = c__2937__auto__);

return statearr_3515;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto__))
);

return c__2937__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4347__auto__ = (((_ == null))?null:_);
var m__4348__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,_);
} else {
var m__4348__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__4348__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,ch);
} else {
var m__4348__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m);
} else {
var m__4348__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async3533 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3533 = (function (ch,cs,meta3534){
this.ch = ch;
this.cs = cs;
this.meta3534 = meta3534;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_3535,meta3534__$1){
var self__ = this;
var _3535__$1 = this;
return (new cljs.core.async.t_cljs$core$async3533(self__.ch,self__.cs,meta3534__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_3535){
var self__ = this;
var _3535__$1 = this;
return self__.meta3534;
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta3534","meta3534",798007377,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async3533.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3533.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3533";

cljs.core.async.t_cljs$core$async3533.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async3533");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3533.
 */
cljs.core.async.__GT_t_cljs$core$async3533 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async3533(ch__$1,cs__$1,meta3534){
return (new cljs.core.async.t_cljs$core$async3533(ch__$1,cs__$1,meta3534));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async3533(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__2937__auto___3755 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3755,cs,m,dchan,dctr,done){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3755,cs,m,dchan,dctr,done){
return (function (state_3670){
var state_val_3671 = (state_3670[(1)]);
if((state_val_3671 === (7))){
var inst_3666 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3672_3756 = state_3670__$1;
(statearr_3672_3756[(2)] = inst_3666);

(statearr_3672_3756[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (20))){
var inst_3569 = (state_3670[(7)]);
var inst_3581 = cljs.core.first.call(null,inst_3569);
var inst_3582 = cljs.core.nth.call(null,inst_3581,(0),null);
var inst_3583 = cljs.core.nth.call(null,inst_3581,(1),null);
var state_3670__$1 = (function (){var statearr_3673 = state_3670;
(statearr_3673[(8)] = inst_3582);

return statearr_3673;
})();
if(cljs.core.truth_(inst_3583)){
var statearr_3674_3757 = state_3670__$1;
(statearr_3674_3757[(1)] = (22));

} else {
var statearr_3675_3758 = state_3670__$1;
(statearr_3675_3758[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (27))){
var inst_3538 = (state_3670[(9)]);
var inst_3618 = (state_3670[(10)]);
var inst_3613 = (state_3670[(11)]);
var inst_3611 = (state_3670[(12)]);
var inst_3618__$1 = cljs.core._nth.call(null,inst_3611,inst_3613);
var inst_3619 = cljs.core.async.put_BANG_.call(null,inst_3618__$1,inst_3538,done);
var state_3670__$1 = (function (){var statearr_3676 = state_3670;
(statearr_3676[(10)] = inst_3618__$1);

return statearr_3676;
})();
if(cljs.core.truth_(inst_3619)){
var statearr_3677_3759 = state_3670__$1;
(statearr_3677_3759[(1)] = (30));

} else {
var statearr_3678_3760 = state_3670__$1;
(statearr_3678_3760[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (1))){
var state_3670__$1 = state_3670;
var statearr_3679_3761 = state_3670__$1;
(statearr_3679_3761[(2)] = null);

(statearr_3679_3761[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (24))){
var inst_3569 = (state_3670[(7)]);
var inst_3588 = (state_3670[(2)]);
var inst_3589 = cljs.core.next.call(null,inst_3569);
var inst_3547 = inst_3589;
var inst_3548 = null;
var inst_3549 = (0);
var inst_3550 = (0);
var state_3670__$1 = (function (){var statearr_3680 = state_3670;
(statearr_3680[(13)] = inst_3549);

(statearr_3680[(14)] = inst_3588);

(statearr_3680[(15)] = inst_3550);

(statearr_3680[(16)] = inst_3548);

(statearr_3680[(17)] = inst_3547);

return statearr_3680;
})();
var statearr_3681_3762 = state_3670__$1;
(statearr_3681_3762[(2)] = null);

(statearr_3681_3762[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (39))){
var state_3670__$1 = state_3670;
var statearr_3685_3763 = state_3670__$1;
(statearr_3685_3763[(2)] = null);

(statearr_3685_3763[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (4))){
var inst_3538 = (state_3670[(9)]);
var inst_3538__$1 = (state_3670[(2)]);
var inst_3539 = (inst_3538__$1 == null);
var state_3670__$1 = (function (){var statearr_3686 = state_3670;
(statearr_3686[(9)] = inst_3538__$1);

return statearr_3686;
})();
if(cljs.core.truth_(inst_3539)){
var statearr_3687_3764 = state_3670__$1;
(statearr_3687_3764[(1)] = (5));

} else {
var statearr_3688_3765 = state_3670__$1;
(statearr_3688_3765[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (15))){
var inst_3549 = (state_3670[(13)]);
var inst_3550 = (state_3670[(15)]);
var inst_3548 = (state_3670[(16)]);
var inst_3547 = (state_3670[(17)]);
var inst_3565 = (state_3670[(2)]);
var inst_3566 = (inst_3550 + (1));
var tmp3682 = inst_3549;
var tmp3683 = inst_3548;
var tmp3684 = inst_3547;
var inst_3547__$1 = tmp3684;
var inst_3548__$1 = tmp3683;
var inst_3549__$1 = tmp3682;
var inst_3550__$1 = inst_3566;
var state_3670__$1 = (function (){var statearr_3689 = state_3670;
(statearr_3689[(18)] = inst_3565);

(statearr_3689[(13)] = inst_3549__$1);

(statearr_3689[(15)] = inst_3550__$1);

(statearr_3689[(16)] = inst_3548__$1);

(statearr_3689[(17)] = inst_3547__$1);

return statearr_3689;
})();
var statearr_3690_3766 = state_3670__$1;
(statearr_3690_3766[(2)] = null);

(statearr_3690_3766[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (21))){
var inst_3592 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3694_3767 = state_3670__$1;
(statearr_3694_3767[(2)] = inst_3592);

(statearr_3694_3767[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (31))){
var inst_3618 = (state_3670[(10)]);
var inst_3622 = done.call(null,null);
var inst_3623 = cljs.core.async.untap_STAR_.call(null,m,inst_3618);
var state_3670__$1 = (function (){var statearr_3695 = state_3670;
(statearr_3695[(19)] = inst_3622);

return statearr_3695;
})();
var statearr_3696_3768 = state_3670__$1;
(statearr_3696_3768[(2)] = inst_3623);

(statearr_3696_3768[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (32))){
var inst_3612 = (state_3670[(20)]);
var inst_3610 = (state_3670[(21)]);
var inst_3613 = (state_3670[(11)]);
var inst_3611 = (state_3670[(12)]);
var inst_3625 = (state_3670[(2)]);
var inst_3626 = (inst_3613 + (1));
var tmp3691 = inst_3612;
var tmp3692 = inst_3610;
var tmp3693 = inst_3611;
var inst_3610__$1 = tmp3692;
var inst_3611__$1 = tmp3693;
var inst_3612__$1 = tmp3691;
var inst_3613__$1 = inst_3626;
var state_3670__$1 = (function (){var statearr_3697 = state_3670;
(statearr_3697[(20)] = inst_3612__$1);

(statearr_3697[(21)] = inst_3610__$1);

(statearr_3697[(11)] = inst_3613__$1);

(statearr_3697[(12)] = inst_3611__$1);

(statearr_3697[(22)] = inst_3625);

return statearr_3697;
})();
var statearr_3698_3769 = state_3670__$1;
(statearr_3698_3769[(2)] = null);

(statearr_3698_3769[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (40))){
var inst_3638 = (state_3670[(23)]);
var inst_3642 = done.call(null,null);
var inst_3643 = cljs.core.async.untap_STAR_.call(null,m,inst_3638);
var state_3670__$1 = (function (){var statearr_3699 = state_3670;
(statearr_3699[(24)] = inst_3642);

return statearr_3699;
})();
var statearr_3700_3770 = state_3670__$1;
(statearr_3700_3770[(2)] = inst_3643);

(statearr_3700_3770[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (33))){
var inst_3629 = (state_3670[(25)]);
var inst_3631 = cljs.core.chunked_seq_QMARK_.call(null,inst_3629);
var state_3670__$1 = state_3670;
if(inst_3631){
var statearr_3701_3771 = state_3670__$1;
(statearr_3701_3771[(1)] = (36));

} else {
var statearr_3702_3772 = state_3670__$1;
(statearr_3702_3772[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (13))){
var inst_3559 = (state_3670[(26)]);
var inst_3562 = cljs.core.async.close_BANG_.call(null,inst_3559);
var state_3670__$1 = state_3670;
var statearr_3703_3773 = state_3670__$1;
(statearr_3703_3773[(2)] = inst_3562);

(statearr_3703_3773[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (22))){
var inst_3582 = (state_3670[(8)]);
var inst_3585 = cljs.core.async.close_BANG_.call(null,inst_3582);
var state_3670__$1 = state_3670;
var statearr_3704_3774 = state_3670__$1;
(statearr_3704_3774[(2)] = inst_3585);

(statearr_3704_3774[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (36))){
var inst_3629 = (state_3670[(25)]);
var inst_3633 = cljs.core.chunk_first.call(null,inst_3629);
var inst_3634 = cljs.core.chunk_rest.call(null,inst_3629);
var inst_3635 = cljs.core.count.call(null,inst_3633);
var inst_3610 = inst_3634;
var inst_3611 = inst_3633;
var inst_3612 = inst_3635;
var inst_3613 = (0);
var state_3670__$1 = (function (){var statearr_3705 = state_3670;
(statearr_3705[(20)] = inst_3612);

(statearr_3705[(21)] = inst_3610);

(statearr_3705[(11)] = inst_3613);

(statearr_3705[(12)] = inst_3611);

return statearr_3705;
})();
var statearr_3706_3775 = state_3670__$1;
(statearr_3706_3775[(2)] = null);

(statearr_3706_3775[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (41))){
var inst_3629 = (state_3670[(25)]);
var inst_3645 = (state_3670[(2)]);
var inst_3646 = cljs.core.next.call(null,inst_3629);
var inst_3610 = inst_3646;
var inst_3611 = null;
var inst_3612 = (0);
var inst_3613 = (0);
var state_3670__$1 = (function (){var statearr_3707 = state_3670;
(statearr_3707[(20)] = inst_3612);

(statearr_3707[(27)] = inst_3645);

(statearr_3707[(21)] = inst_3610);

(statearr_3707[(11)] = inst_3613);

(statearr_3707[(12)] = inst_3611);

return statearr_3707;
})();
var statearr_3708_3776 = state_3670__$1;
(statearr_3708_3776[(2)] = null);

(statearr_3708_3776[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (43))){
var state_3670__$1 = state_3670;
var statearr_3709_3777 = state_3670__$1;
(statearr_3709_3777[(2)] = null);

(statearr_3709_3777[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (29))){
var inst_3654 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3710_3778 = state_3670__$1;
(statearr_3710_3778[(2)] = inst_3654);

(statearr_3710_3778[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (44))){
var inst_3663 = (state_3670[(2)]);
var state_3670__$1 = (function (){var statearr_3711 = state_3670;
(statearr_3711[(28)] = inst_3663);

return statearr_3711;
})();
var statearr_3712_3779 = state_3670__$1;
(statearr_3712_3779[(2)] = null);

(statearr_3712_3779[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (6))){
var inst_3602 = (state_3670[(29)]);
var inst_3601 = cljs.core.deref.call(null,cs);
var inst_3602__$1 = cljs.core.keys.call(null,inst_3601);
var inst_3603 = cljs.core.count.call(null,inst_3602__$1);
var inst_3604 = cljs.core.reset_BANG_.call(null,dctr,inst_3603);
var inst_3609 = cljs.core.seq.call(null,inst_3602__$1);
var inst_3610 = inst_3609;
var inst_3611 = null;
var inst_3612 = (0);
var inst_3613 = (0);
var state_3670__$1 = (function (){var statearr_3713 = state_3670;
(statearr_3713[(20)] = inst_3612);

(statearr_3713[(21)] = inst_3610);

(statearr_3713[(29)] = inst_3602__$1);

(statearr_3713[(11)] = inst_3613);

(statearr_3713[(12)] = inst_3611);

(statearr_3713[(30)] = inst_3604);

return statearr_3713;
})();
var statearr_3714_3780 = state_3670__$1;
(statearr_3714_3780[(2)] = null);

(statearr_3714_3780[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (28))){
var inst_3610 = (state_3670[(21)]);
var inst_3629 = (state_3670[(25)]);
var inst_3629__$1 = cljs.core.seq.call(null,inst_3610);
var state_3670__$1 = (function (){var statearr_3715 = state_3670;
(statearr_3715[(25)] = inst_3629__$1);

return statearr_3715;
})();
if(inst_3629__$1){
var statearr_3716_3781 = state_3670__$1;
(statearr_3716_3781[(1)] = (33));

} else {
var statearr_3717_3782 = state_3670__$1;
(statearr_3717_3782[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (25))){
var inst_3612 = (state_3670[(20)]);
var inst_3613 = (state_3670[(11)]);
var inst_3615 = (inst_3613 < inst_3612);
var inst_3616 = inst_3615;
var state_3670__$1 = state_3670;
if(cljs.core.truth_(inst_3616)){
var statearr_3718_3783 = state_3670__$1;
(statearr_3718_3783[(1)] = (27));

} else {
var statearr_3719_3784 = state_3670__$1;
(statearr_3719_3784[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (34))){
var state_3670__$1 = state_3670;
var statearr_3720_3785 = state_3670__$1;
(statearr_3720_3785[(2)] = null);

(statearr_3720_3785[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (17))){
var state_3670__$1 = state_3670;
var statearr_3721_3786 = state_3670__$1;
(statearr_3721_3786[(2)] = null);

(statearr_3721_3786[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (3))){
var inst_3668 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3670__$1,inst_3668);
} else {
if((state_val_3671 === (12))){
var inst_3597 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3722_3787 = state_3670__$1;
(statearr_3722_3787[(2)] = inst_3597);

(statearr_3722_3787[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (2))){
var state_3670__$1 = state_3670;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3670__$1,(4),ch);
} else {
if((state_val_3671 === (23))){
var state_3670__$1 = state_3670;
var statearr_3723_3788 = state_3670__$1;
(statearr_3723_3788[(2)] = null);

(statearr_3723_3788[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (35))){
var inst_3652 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3724_3789 = state_3670__$1;
(statearr_3724_3789[(2)] = inst_3652);

(statearr_3724_3789[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (19))){
var inst_3569 = (state_3670[(7)]);
var inst_3573 = cljs.core.chunk_first.call(null,inst_3569);
var inst_3574 = cljs.core.chunk_rest.call(null,inst_3569);
var inst_3575 = cljs.core.count.call(null,inst_3573);
var inst_3547 = inst_3574;
var inst_3548 = inst_3573;
var inst_3549 = inst_3575;
var inst_3550 = (0);
var state_3670__$1 = (function (){var statearr_3725 = state_3670;
(statearr_3725[(13)] = inst_3549);

(statearr_3725[(15)] = inst_3550);

(statearr_3725[(16)] = inst_3548);

(statearr_3725[(17)] = inst_3547);

return statearr_3725;
})();
var statearr_3726_3790 = state_3670__$1;
(statearr_3726_3790[(2)] = null);

(statearr_3726_3790[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (11))){
var inst_3569 = (state_3670[(7)]);
var inst_3547 = (state_3670[(17)]);
var inst_3569__$1 = cljs.core.seq.call(null,inst_3547);
var state_3670__$1 = (function (){var statearr_3727 = state_3670;
(statearr_3727[(7)] = inst_3569__$1);

return statearr_3727;
})();
if(inst_3569__$1){
var statearr_3728_3791 = state_3670__$1;
(statearr_3728_3791[(1)] = (16));

} else {
var statearr_3729_3792 = state_3670__$1;
(statearr_3729_3792[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (9))){
var inst_3599 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3730_3793 = state_3670__$1;
(statearr_3730_3793[(2)] = inst_3599);

(statearr_3730_3793[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (5))){
var inst_3545 = cljs.core.deref.call(null,cs);
var inst_3546 = cljs.core.seq.call(null,inst_3545);
var inst_3547 = inst_3546;
var inst_3548 = null;
var inst_3549 = (0);
var inst_3550 = (0);
var state_3670__$1 = (function (){var statearr_3731 = state_3670;
(statearr_3731[(13)] = inst_3549);

(statearr_3731[(15)] = inst_3550);

(statearr_3731[(16)] = inst_3548);

(statearr_3731[(17)] = inst_3547);

return statearr_3731;
})();
var statearr_3732_3794 = state_3670__$1;
(statearr_3732_3794[(2)] = null);

(statearr_3732_3794[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (14))){
var state_3670__$1 = state_3670;
var statearr_3733_3795 = state_3670__$1;
(statearr_3733_3795[(2)] = null);

(statearr_3733_3795[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (45))){
var inst_3660 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3734_3796 = state_3670__$1;
(statearr_3734_3796[(2)] = inst_3660);

(statearr_3734_3796[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (26))){
var inst_3602 = (state_3670[(29)]);
var inst_3656 = (state_3670[(2)]);
var inst_3657 = cljs.core.seq.call(null,inst_3602);
var state_3670__$1 = (function (){var statearr_3735 = state_3670;
(statearr_3735[(31)] = inst_3656);

return statearr_3735;
})();
if(inst_3657){
var statearr_3736_3797 = state_3670__$1;
(statearr_3736_3797[(1)] = (42));

} else {
var statearr_3737_3798 = state_3670__$1;
(statearr_3737_3798[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (16))){
var inst_3569 = (state_3670[(7)]);
var inst_3571 = cljs.core.chunked_seq_QMARK_.call(null,inst_3569);
var state_3670__$1 = state_3670;
if(inst_3571){
var statearr_3738_3799 = state_3670__$1;
(statearr_3738_3799[(1)] = (19));

} else {
var statearr_3739_3800 = state_3670__$1;
(statearr_3739_3800[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (38))){
var inst_3649 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3740_3801 = state_3670__$1;
(statearr_3740_3801[(2)] = inst_3649);

(statearr_3740_3801[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (30))){
var state_3670__$1 = state_3670;
var statearr_3741_3802 = state_3670__$1;
(statearr_3741_3802[(2)] = null);

(statearr_3741_3802[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (10))){
var inst_3550 = (state_3670[(15)]);
var inst_3548 = (state_3670[(16)]);
var inst_3558 = cljs.core._nth.call(null,inst_3548,inst_3550);
var inst_3559 = cljs.core.nth.call(null,inst_3558,(0),null);
var inst_3560 = cljs.core.nth.call(null,inst_3558,(1),null);
var state_3670__$1 = (function (){var statearr_3742 = state_3670;
(statearr_3742[(26)] = inst_3559);

return statearr_3742;
})();
if(cljs.core.truth_(inst_3560)){
var statearr_3743_3803 = state_3670__$1;
(statearr_3743_3803[(1)] = (13));

} else {
var statearr_3744_3804 = state_3670__$1;
(statearr_3744_3804[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (18))){
var inst_3595 = (state_3670[(2)]);
var state_3670__$1 = state_3670;
var statearr_3745_3805 = state_3670__$1;
(statearr_3745_3805[(2)] = inst_3595);

(statearr_3745_3805[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (42))){
var state_3670__$1 = state_3670;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3670__$1,(45),dchan);
} else {
if((state_val_3671 === (37))){
var inst_3538 = (state_3670[(9)]);
var inst_3629 = (state_3670[(25)]);
var inst_3638 = (state_3670[(23)]);
var inst_3638__$1 = cljs.core.first.call(null,inst_3629);
var inst_3639 = cljs.core.async.put_BANG_.call(null,inst_3638__$1,inst_3538,done);
var state_3670__$1 = (function (){var statearr_3746 = state_3670;
(statearr_3746[(23)] = inst_3638__$1);

return statearr_3746;
})();
if(cljs.core.truth_(inst_3639)){
var statearr_3747_3806 = state_3670__$1;
(statearr_3747_3806[(1)] = (39));

} else {
var statearr_3748_3807 = state_3670__$1;
(statearr_3748_3807[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3671 === (8))){
var inst_3549 = (state_3670[(13)]);
var inst_3550 = (state_3670[(15)]);
var inst_3552 = (inst_3550 < inst_3549);
var inst_3553 = inst_3552;
var state_3670__$1 = state_3670;
if(cljs.core.truth_(inst_3553)){
var statearr_3749_3808 = state_3670__$1;
(statearr_3749_3808[(1)] = (10));

} else {
var statearr_3750_3809 = state_3670__$1;
(statearr_3750_3809[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___3755,cs,m,dchan,dctr,done))
;
return ((function (switch__2842__auto__,c__2937__auto___3755,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__2843__auto__ = null;
var cljs$core$async$mult_$_state_machine__2843__auto____0 = (function (){
var statearr_3751 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_3751[(0)] = cljs$core$async$mult_$_state_machine__2843__auto__);

(statearr_3751[(1)] = (1));

return statearr_3751;
});
var cljs$core$async$mult_$_state_machine__2843__auto____1 = (function (state_3670){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3670);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3752){if((e3752 instanceof Object)){
var ex__2846__auto__ = e3752;
var statearr_3753_3810 = state_3670;
(statearr_3753_3810[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3670);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3752;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3811 = state_3670;
state_3670 = G__3811;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__2843__auto__ = function(state_3670){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__2843__auto____1.call(this,state_3670);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__2843__auto____0;
cljs$core$async$mult_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__2843__auto____1;
return cljs$core$async$mult_$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3755,cs,m,dchan,dctr,done))
})();
var state__2939__auto__ = (function (){var statearr_3754 = f__2938__auto__.call(null);
(statearr_3754[(6)] = c__2937__auto___3755);

return statearr_3754;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3755,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__3813 = arguments.length;
switch (G__3813) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,ch);
} else {
var m__4348__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,ch);
} else {
var m__4348__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m);
} else {
var m__4348__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,state_map);
} else {
var m__4348__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4347__auto__ = (((m == null))?null:m);
var m__4348__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,m,mode);
} else {
var m__4348__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4647__auto__ = [];
var len__4641__auto___3825 = arguments.length;
var i__4642__auto___3826 = (0);
while(true){
if((i__4642__auto___3826 < len__4641__auto___3825)){
args__4647__auto__.push((arguments[i__4642__auto___3826]));

var G__3827 = (i__4642__auto___3826 + (1));
i__4642__auto___3826 = G__3827;
continue;
} else {
}
break;
}

var argseq__4648__auto__ = ((((3) < args__4647__auto__.length))?(new cljs.core.IndexedSeq(args__4647__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4648__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__3819){
var map__3820 = p__3819;
var map__3820__$1 = (((((!((map__3820 == null))))?(((((map__3820.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__3820.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__3820):map__3820);
var opts = map__3820__$1;
var statearr_3822_3828 = state;
(statearr_3822_3828[(1)] = cont_block);


var temp__5735__auto__ = cljs.core.async.do_alts.call(null,((function (map__3820,map__3820__$1,opts){
return (function (val){
var statearr_3823_3829 = state;
(statearr_3823_3829[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__3820,map__3820__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__5735__auto__)){
var cb = temp__5735__auto__;
var statearr_3824_3830 = state;
(statearr_3824_3830[(2)] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq3815){
var G__3816 = cljs.core.first.call(null,seq3815);
var seq3815__$1 = cljs.core.next.call(null,seq3815);
var G__3817 = cljs.core.first.call(null,seq3815__$1);
var seq3815__$2 = cljs.core.next.call(null,seq3815__$1);
var G__3818 = cljs.core.first.call(null,seq3815__$2);
var seq3815__$3 = cljs.core.next.call(null,seq3815__$2);
var self__4628__auto__ = this;
return self__4628__auto__.cljs$core$IFn$_invoke$arity$variadic(G__3816,G__3817,G__3818,seq3815__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,((((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && ((!(cljs.core.empty_QMARK_.call(null,solos))))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async3831 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3831 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta3832){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta3832 = meta3832;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_3833,meta3832__$1){
var self__ = this;
var _3833__$1 = this;
return (new cljs.core.async.t_cljs$core$async3831(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta3832__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_3833){
var self__ = this;
var _3833__$1 = this;
return self__.meta3832;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join('')),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta3832","meta3832",1258341098,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async3831.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3831.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3831";

cljs.core.async.t_cljs$core$async3831.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async3831");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3831.
 */
cljs.core.async.__GT_t_cljs$core$async3831 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async3831(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta3832){
return (new cljs.core.async.t_cljs$core$async3831(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta3832));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async3831(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__2937__auto___3995 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_3935){
var state_val_3936 = (state_3935[(1)]);
if((state_val_3936 === (7))){
var inst_3850 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
var statearr_3937_3996 = state_3935__$1;
(statearr_3937_3996[(2)] = inst_3850);

(statearr_3937_3996[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (20))){
var inst_3862 = (state_3935[(7)]);
var state_3935__$1 = state_3935;
var statearr_3938_3997 = state_3935__$1;
(statearr_3938_3997[(2)] = inst_3862);

(statearr_3938_3997[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (27))){
var state_3935__$1 = state_3935;
var statearr_3939_3998 = state_3935__$1;
(statearr_3939_3998[(2)] = null);

(statearr_3939_3998[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (1))){
var inst_3837 = (state_3935[(8)]);
var inst_3837__$1 = calc_state.call(null);
var inst_3839 = (inst_3837__$1 == null);
var inst_3840 = cljs.core.not.call(null,inst_3839);
var state_3935__$1 = (function (){var statearr_3940 = state_3935;
(statearr_3940[(8)] = inst_3837__$1);

return statearr_3940;
})();
if(inst_3840){
var statearr_3941_3999 = state_3935__$1;
(statearr_3941_3999[(1)] = (2));

} else {
var statearr_3942_4000 = state_3935__$1;
(statearr_3942_4000[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (24))){
var inst_3886 = (state_3935[(9)]);
var inst_3909 = (state_3935[(10)]);
var inst_3895 = (state_3935[(11)]);
var inst_3909__$1 = inst_3886.call(null,inst_3895);
var state_3935__$1 = (function (){var statearr_3943 = state_3935;
(statearr_3943[(10)] = inst_3909__$1);

return statearr_3943;
})();
if(cljs.core.truth_(inst_3909__$1)){
var statearr_3944_4001 = state_3935__$1;
(statearr_3944_4001[(1)] = (29));

} else {
var statearr_3945_4002 = state_3935__$1;
(statearr_3945_4002[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (4))){
var inst_3853 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3853)){
var statearr_3946_4003 = state_3935__$1;
(statearr_3946_4003[(1)] = (8));

} else {
var statearr_3947_4004 = state_3935__$1;
(statearr_3947_4004[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (15))){
var inst_3880 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3880)){
var statearr_3948_4005 = state_3935__$1;
(statearr_3948_4005[(1)] = (19));

} else {
var statearr_3949_4006 = state_3935__$1;
(statearr_3949_4006[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (21))){
var inst_3885 = (state_3935[(12)]);
var inst_3885__$1 = (state_3935[(2)]);
var inst_3886 = cljs.core.get.call(null,inst_3885__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_3887 = cljs.core.get.call(null,inst_3885__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_3888 = cljs.core.get.call(null,inst_3885__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_3935__$1 = (function (){var statearr_3950 = state_3935;
(statearr_3950[(13)] = inst_3887);

(statearr_3950[(12)] = inst_3885__$1);

(statearr_3950[(9)] = inst_3886);

return statearr_3950;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_3935__$1,(22),inst_3888);
} else {
if((state_val_3936 === (31))){
var inst_3917 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3917)){
var statearr_3951_4007 = state_3935__$1;
(statearr_3951_4007[(1)] = (32));

} else {
var statearr_3952_4008 = state_3935__$1;
(statearr_3952_4008[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (32))){
var inst_3894 = (state_3935[(14)]);
var state_3935__$1 = state_3935;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3935__$1,(35),out,inst_3894);
} else {
if((state_val_3936 === (33))){
var inst_3885 = (state_3935[(12)]);
var inst_3862 = inst_3885;
var state_3935__$1 = (function (){var statearr_3953 = state_3935;
(statearr_3953[(7)] = inst_3862);

return statearr_3953;
})();
var statearr_3954_4009 = state_3935__$1;
(statearr_3954_4009[(2)] = null);

(statearr_3954_4009[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (13))){
var inst_3862 = (state_3935[(7)]);
var inst_3869 = inst_3862.cljs$lang$protocol_mask$partition0$;
var inst_3870 = (inst_3869 & (64));
var inst_3871 = inst_3862.cljs$core$ISeq$;
var inst_3872 = (cljs.core.PROTOCOL_SENTINEL === inst_3871);
var inst_3873 = ((inst_3870) || (inst_3872));
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3873)){
var statearr_3955_4010 = state_3935__$1;
(statearr_3955_4010[(1)] = (16));

} else {
var statearr_3956_4011 = state_3935__$1;
(statearr_3956_4011[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (22))){
var inst_3894 = (state_3935[(14)]);
var inst_3895 = (state_3935[(11)]);
var inst_3893 = (state_3935[(2)]);
var inst_3894__$1 = cljs.core.nth.call(null,inst_3893,(0),null);
var inst_3895__$1 = cljs.core.nth.call(null,inst_3893,(1),null);
var inst_3896 = (inst_3894__$1 == null);
var inst_3897 = cljs.core._EQ_.call(null,inst_3895__$1,change);
var inst_3898 = ((inst_3896) || (inst_3897));
var state_3935__$1 = (function (){var statearr_3957 = state_3935;
(statearr_3957[(14)] = inst_3894__$1);

(statearr_3957[(11)] = inst_3895__$1);

return statearr_3957;
})();
if(cljs.core.truth_(inst_3898)){
var statearr_3958_4012 = state_3935__$1;
(statearr_3958_4012[(1)] = (23));

} else {
var statearr_3959_4013 = state_3935__$1;
(statearr_3959_4013[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (36))){
var inst_3885 = (state_3935[(12)]);
var inst_3862 = inst_3885;
var state_3935__$1 = (function (){var statearr_3960 = state_3935;
(statearr_3960[(7)] = inst_3862);

return statearr_3960;
})();
var statearr_3961_4014 = state_3935__$1;
(statearr_3961_4014[(2)] = null);

(statearr_3961_4014[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (29))){
var inst_3909 = (state_3935[(10)]);
var state_3935__$1 = state_3935;
var statearr_3962_4015 = state_3935__$1;
(statearr_3962_4015[(2)] = inst_3909);

(statearr_3962_4015[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (6))){
var state_3935__$1 = state_3935;
var statearr_3963_4016 = state_3935__$1;
(statearr_3963_4016[(2)] = false);

(statearr_3963_4016[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (28))){
var inst_3905 = (state_3935[(2)]);
var inst_3906 = calc_state.call(null);
var inst_3862 = inst_3906;
var state_3935__$1 = (function (){var statearr_3964 = state_3935;
(statearr_3964[(15)] = inst_3905);

(statearr_3964[(7)] = inst_3862);

return statearr_3964;
})();
var statearr_3965_4017 = state_3935__$1;
(statearr_3965_4017[(2)] = null);

(statearr_3965_4017[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (25))){
var inst_3931 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
var statearr_3966_4018 = state_3935__$1;
(statearr_3966_4018[(2)] = inst_3931);

(statearr_3966_4018[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (34))){
var inst_3929 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
var statearr_3967_4019 = state_3935__$1;
(statearr_3967_4019[(2)] = inst_3929);

(statearr_3967_4019[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (17))){
var state_3935__$1 = state_3935;
var statearr_3968_4020 = state_3935__$1;
(statearr_3968_4020[(2)] = false);

(statearr_3968_4020[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (3))){
var state_3935__$1 = state_3935;
var statearr_3969_4021 = state_3935__$1;
(statearr_3969_4021[(2)] = false);

(statearr_3969_4021[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (12))){
var inst_3933 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3935__$1,inst_3933);
} else {
if((state_val_3936 === (2))){
var inst_3837 = (state_3935[(8)]);
var inst_3842 = inst_3837.cljs$lang$protocol_mask$partition0$;
var inst_3843 = (inst_3842 & (64));
var inst_3844 = inst_3837.cljs$core$ISeq$;
var inst_3845 = (cljs.core.PROTOCOL_SENTINEL === inst_3844);
var inst_3846 = ((inst_3843) || (inst_3845));
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3846)){
var statearr_3970_4022 = state_3935__$1;
(statearr_3970_4022[(1)] = (5));

} else {
var statearr_3971_4023 = state_3935__$1;
(statearr_3971_4023[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (23))){
var inst_3894 = (state_3935[(14)]);
var inst_3900 = (inst_3894 == null);
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3900)){
var statearr_3972_4024 = state_3935__$1;
(statearr_3972_4024[(1)] = (26));

} else {
var statearr_3973_4025 = state_3935__$1;
(statearr_3973_4025[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (35))){
var inst_3920 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
if(cljs.core.truth_(inst_3920)){
var statearr_3974_4026 = state_3935__$1;
(statearr_3974_4026[(1)] = (36));

} else {
var statearr_3975_4027 = state_3935__$1;
(statearr_3975_4027[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (19))){
var inst_3862 = (state_3935[(7)]);
var inst_3882 = cljs.core.apply.call(null,cljs.core.hash_map,inst_3862);
var state_3935__$1 = state_3935;
var statearr_3976_4028 = state_3935__$1;
(statearr_3976_4028[(2)] = inst_3882);

(statearr_3976_4028[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (11))){
var inst_3862 = (state_3935[(7)]);
var inst_3866 = (inst_3862 == null);
var inst_3867 = cljs.core.not.call(null,inst_3866);
var state_3935__$1 = state_3935;
if(inst_3867){
var statearr_3977_4029 = state_3935__$1;
(statearr_3977_4029[(1)] = (13));

} else {
var statearr_3978_4030 = state_3935__$1;
(statearr_3978_4030[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (9))){
var inst_3837 = (state_3935[(8)]);
var state_3935__$1 = state_3935;
var statearr_3979_4031 = state_3935__$1;
(statearr_3979_4031[(2)] = inst_3837);

(statearr_3979_4031[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (5))){
var state_3935__$1 = state_3935;
var statearr_3980_4032 = state_3935__$1;
(statearr_3980_4032[(2)] = true);

(statearr_3980_4032[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (14))){
var state_3935__$1 = state_3935;
var statearr_3981_4033 = state_3935__$1;
(statearr_3981_4033[(2)] = false);

(statearr_3981_4033[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (26))){
var inst_3895 = (state_3935[(11)]);
var inst_3902 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_3895);
var state_3935__$1 = state_3935;
var statearr_3982_4034 = state_3935__$1;
(statearr_3982_4034[(2)] = inst_3902);

(statearr_3982_4034[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (16))){
var state_3935__$1 = state_3935;
var statearr_3983_4035 = state_3935__$1;
(statearr_3983_4035[(2)] = true);

(statearr_3983_4035[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (38))){
var inst_3925 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
var statearr_3984_4036 = state_3935__$1;
(statearr_3984_4036[(2)] = inst_3925);

(statearr_3984_4036[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (30))){
var inst_3887 = (state_3935[(13)]);
var inst_3886 = (state_3935[(9)]);
var inst_3895 = (state_3935[(11)]);
var inst_3912 = cljs.core.empty_QMARK_.call(null,inst_3886);
var inst_3913 = inst_3887.call(null,inst_3895);
var inst_3914 = cljs.core.not.call(null,inst_3913);
var inst_3915 = ((inst_3912) && (inst_3914));
var state_3935__$1 = state_3935;
var statearr_3985_4037 = state_3935__$1;
(statearr_3985_4037[(2)] = inst_3915);

(statearr_3985_4037[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (10))){
var inst_3837 = (state_3935[(8)]);
var inst_3858 = (state_3935[(2)]);
var inst_3859 = cljs.core.get.call(null,inst_3858,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_3860 = cljs.core.get.call(null,inst_3858,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_3861 = cljs.core.get.call(null,inst_3858,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_3862 = inst_3837;
var state_3935__$1 = (function (){var statearr_3986 = state_3935;
(statearr_3986[(16)] = inst_3859);

(statearr_3986[(17)] = inst_3860);

(statearr_3986[(18)] = inst_3861);

(statearr_3986[(7)] = inst_3862);

return statearr_3986;
})();
var statearr_3987_4038 = state_3935__$1;
(statearr_3987_4038[(2)] = null);

(statearr_3987_4038[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (18))){
var inst_3877 = (state_3935[(2)]);
var state_3935__$1 = state_3935;
var statearr_3988_4039 = state_3935__$1;
(statearr_3988_4039[(2)] = inst_3877);

(statearr_3988_4039[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (37))){
var state_3935__$1 = state_3935;
var statearr_3989_4040 = state_3935__$1;
(statearr_3989_4040[(2)] = null);

(statearr_3989_4040[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3936 === (8))){
var inst_3837 = (state_3935[(8)]);
var inst_3855 = cljs.core.apply.call(null,cljs.core.hash_map,inst_3837);
var state_3935__$1 = state_3935;
var statearr_3990_4041 = state_3935__$1;
(statearr_3990_4041[(2)] = inst_3855);

(statearr_3990_4041[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__2842__auto__,c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__2843__auto__ = null;
var cljs$core$async$mix_$_state_machine__2843__auto____0 = (function (){
var statearr_3991 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_3991[(0)] = cljs$core$async$mix_$_state_machine__2843__auto__);

(statearr_3991[(1)] = (1));

return statearr_3991;
});
var cljs$core$async$mix_$_state_machine__2843__auto____1 = (function (state_3935){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_3935);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e3992){if((e3992 instanceof Object)){
var ex__2846__auto__ = e3992;
var statearr_3993_4042 = state_3935;
(statearr_3993_4042[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3935);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3992;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4043 = state_3935;
state_3935 = G__4043;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__2843__auto__ = function(state_3935){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__2843__auto____1.call(this,state_3935);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__2843__auto____0;
cljs$core$async$mix_$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__2843__auto____1;
return cljs$core$async$mix_$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__2939__auto__ = (function (){var statearr_3994 = f__2938__auto__.call(null);
(statearr_3994[(6)] = c__2937__auto___3995);

return statearr_3994;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___3995,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4347__auto__ = (((p == null))?null:p);
var m__4348__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__4348__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4347__auto__ = (((p == null))?null:p);
var m__4348__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,p,v,ch);
} else {
var m__4348__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__4045 = arguments.length;
switch (G__4045) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4347__auto__ = (((p == null))?null:p);
var m__4348__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,p);
} else {
var m__4348__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4347__auto__ = (((p == null))?null:p);
var m__4348__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4347__auto__)]);
if((!((m__4348__auto__ == null)))){
return m__4348__auto__.call(null,p,v);
} else {
var m__4348__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4348__auto____$1 == null)))){
return m__4348__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__4049 = arguments.length;
switch (G__4049) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__4047__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__4047__auto__)){
return or__4047__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__4047__auto__,mults){
return (function (p1__4047_SHARP_){
if(cljs.core.truth_(p1__4047_SHARP_.call(null,topic))){
return p1__4047_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__4047_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__4047__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async4050 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4050 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta4051){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta4051 = meta4051;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_4052,meta4051__$1){
var self__ = this;
var _4052__$1 = this;
return (new cljs.core.async.t_cljs$core$async4050(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta4051__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_4052){
var self__ = this;
var _4052__$1 = this;
return self__.meta4051;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5735__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__5735__auto__)){
var m = temp__5735__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta4051","meta4051",373861472,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4050.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4050.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4050";

cljs.core.async.t_cljs$core$async4050.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async4050");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4050.
 */
cljs.core.async.__GT_t_cljs$core$async4050 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async4050(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta4051){
return (new cljs.core.async.t_cljs$core$async4050(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta4051));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async4050(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__2937__auto___4170 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4170,mults,ensure_mult,p){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4170,mults,ensure_mult,p){
return (function (state_4124){
var state_val_4125 = (state_4124[(1)]);
if((state_val_4125 === (7))){
var inst_4120 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4126_4171 = state_4124__$1;
(statearr_4126_4171[(2)] = inst_4120);

(statearr_4126_4171[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (20))){
var state_4124__$1 = state_4124;
var statearr_4127_4172 = state_4124__$1;
(statearr_4127_4172[(2)] = null);

(statearr_4127_4172[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (1))){
var state_4124__$1 = state_4124;
var statearr_4128_4173 = state_4124__$1;
(statearr_4128_4173[(2)] = null);

(statearr_4128_4173[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (24))){
var inst_4103 = (state_4124[(7)]);
var inst_4112 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_4103);
var state_4124__$1 = state_4124;
var statearr_4129_4174 = state_4124__$1;
(statearr_4129_4174[(2)] = inst_4112);

(statearr_4129_4174[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (4))){
var inst_4055 = (state_4124[(8)]);
var inst_4055__$1 = (state_4124[(2)]);
var inst_4056 = (inst_4055__$1 == null);
var state_4124__$1 = (function (){var statearr_4130 = state_4124;
(statearr_4130[(8)] = inst_4055__$1);

return statearr_4130;
})();
if(cljs.core.truth_(inst_4056)){
var statearr_4131_4175 = state_4124__$1;
(statearr_4131_4175[(1)] = (5));

} else {
var statearr_4132_4176 = state_4124__$1;
(statearr_4132_4176[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (15))){
var inst_4097 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4133_4177 = state_4124__$1;
(statearr_4133_4177[(2)] = inst_4097);

(statearr_4133_4177[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (21))){
var inst_4117 = (state_4124[(2)]);
var state_4124__$1 = (function (){var statearr_4134 = state_4124;
(statearr_4134[(9)] = inst_4117);

return statearr_4134;
})();
var statearr_4135_4178 = state_4124__$1;
(statearr_4135_4178[(2)] = null);

(statearr_4135_4178[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (13))){
var inst_4079 = (state_4124[(10)]);
var inst_4081 = cljs.core.chunked_seq_QMARK_.call(null,inst_4079);
var state_4124__$1 = state_4124;
if(inst_4081){
var statearr_4136_4179 = state_4124__$1;
(statearr_4136_4179[(1)] = (16));

} else {
var statearr_4137_4180 = state_4124__$1;
(statearr_4137_4180[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (22))){
var inst_4109 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
if(cljs.core.truth_(inst_4109)){
var statearr_4138_4181 = state_4124__$1;
(statearr_4138_4181[(1)] = (23));

} else {
var statearr_4139_4182 = state_4124__$1;
(statearr_4139_4182[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (6))){
var inst_4105 = (state_4124[(11)]);
var inst_4103 = (state_4124[(7)]);
var inst_4055 = (state_4124[(8)]);
var inst_4103__$1 = topic_fn.call(null,inst_4055);
var inst_4104 = cljs.core.deref.call(null,mults);
var inst_4105__$1 = cljs.core.get.call(null,inst_4104,inst_4103__$1);
var state_4124__$1 = (function (){var statearr_4140 = state_4124;
(statearr_4140[(11)] = inst_4105__$1);

(statearr_4140[(7)] = inst_4103__$1);

return statearr_4140;
})();
if(cljs.core.truth_(inst_4105__$1)){
var statearr_4141_4183 = state_4124__$1;
(statearr_4141_4183[(1)] = (19));

} else {
var statearr_4142_4184 = state_4124__$1;
(statearr_4142_4184[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (25))){
var inst_4114 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4143_4185 = state_4124__$1;
(statearr_4143_4185[(2)] = inst_4114);

(statearr_4143_4185[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (17))){
var inst_4079 = (state_4124[(10)]);
var inst_4088 = cljs.core.first.call(null,inst_4079);
var inst_4089 = cljs.core.async.muxch_STAR_.call(null,inst_4088);
var inst_4090 = cljs.core.async.close_BANG_.call(null,inst_4089);
var inst_4091 = cljs.core.next.call(null,inst_4079);
var inst_4065 = inst_4091;
var inst_4066 = null;
var inst_4067 = (0);
var inst_4068 = (0);
var state_4124__$1 = (function (){var statearr_4144 = state_4124;
(statearr_4144[(12)] = inst_4065);

(statearr_4144[(13)] = inst_4067);

(statearr_4144[(14)] = inst_4090);

(statearr_4144[(15)] = inst_4066);

(statearr_4144[(16)] = inst_4068);

return statearr_4144;
})();
var statearr_4145_4186 = state_4124__$1;
(statearr_4145_4186[(2)] = null);

(statearr_4145_4186[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (3))){
var inst_4122 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4124__$1,inst_4122);
} else {
if((state_val_4125 === (12))){
var inst_4099 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4146_4187 = state_4124__$1;
(statearr_4146_4187[(2)] = inst_4099);

(statearr_4146_4187[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (2))){
var state_4124__$1 = state_4124;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4124__$1,(4),ch);
} else {
if((state_val_4125 === (23))){
var state_4124__$1 = state_4124;
var statearr_4147_4188 = state_4124__$1;
(statearr_4147_4188[(2)] = null);

(statearr_4147_4188[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (19))){
var inst_4105 = (state_4124[(11)]);
var inst_4055 = (state_4124[(8)]);
var inst_4107 = cljs.core.async.muxch_STAR_.call(null,inst_4105);
var state_4124__$1 = state_4124;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4124__$1,(22),inst_4107,inst_4055);
} else {
if((state_val_4125 === (11))){
var inst_4065 = (state_4124[(12)]);
var inst_4079 = (state_4124[(10)]);
var inst_4079__$1 = cljs.core.seq.call(null,inst_4065);
var state_4124__$1 = (function (){var statearr_4148 = state_4124;
(statearr_4148[(10)] = inst_4079__$1);

return statearr_4148;
})();
if(inst_4079__$1){
var statearr_4149_4189 = state_4124__$1;
(statearr_4149_4189[(1)] = (13));

} else {
var statearr_4150_4190 = state_4124__$1;
(statearr_4150_4190[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (9))){
var inst_4101 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4151_4191 = state_4124__$1;
(statearr_4151_4191[(2)] = inst_4101);

(statearr_4151_4191[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (5))){
var inst_4062 = cljs.core.deref.call(null,mults);
var inst_4063 = cljs.core.vals.call(null,inst_4062);
var inst_4064 = cljs.core.seq.call(null,inst_4063);
var inst_4065 = inst_4064;
var inst_4066 = null;
var inst_4067 = (0);
var inst_4068 = (0);
var state_4124__$1 = (function (){var statearr_4152 = state_4124;
(statearr_4152[(12)] = inst_4065);

(statearr_4152[(13)] = inst_4067);

(statearr_4152[(15)] = inst_4066);

(statearr_4152[(16)] = inst_4068);

return statearr_4152;
})();
var statearr_4153_4192 = state_4124__$1;
(statearr_4153_4192[(2)] = null);

(statearr_4153_4192[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (14))){
var state_4124__$1 = state_4124;
var statearr_4157_4193 = state_4124__$1;
(statearr_4157_4193[(2)] = null);

(statearr_4157_4193[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (16))){
var inst_4079 = (state_4124[(10)]);
var inst_4083 = cljs.core.chunk_first.call(null,inst_4079);
var inst_4084 = cljs.core.chunk_rest.call(null,inst_4079);
var inst_4085 = cljs.core.count.call(null,inst_4083);
var inst_4065 = inst_4084;
var inst_4066 = inst_4083;
var inst_4067 = inst_4085;
var inst_4068 = (0);
var state_4124__$1 = (function (){var statearr_4158 = state_4124;
(statearr_4158[(12)] = inst_4065);

(statearr_4158[(13)] = inst_4067);

(statearr_4158[(15)] = inst_4066);

(statearr_4158[(16)] = inst_4068);

return statearr_4158;
})();
var statearr_4159_4194 = state_4124__$1;
(statearr_4159_4194[(2)] = null);

(statearr_4159_4194[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (10))){
var inst_4065 = (state_4124[(12)]);
var inst_4067 = (state_4124[(13)]);
var inst_4066 = (state_4124[(15)]);
var inst_4068 = (state_4124[(16)]);
var inst_4073 = cljs.core._nth.call(null,inst_4066,inst_4068);
var inst_4074 = cljs.core.async.muxch_STAR_.call(null,inst_4073);
var inst_4075 = cljs.core.async.close_BANG_.call(null,inst_4074);
var inst_4076 = (inst_4068 + (1));
var tmp4154 = inst_4065;
var tmp4155 = inst_4067;
var tmp4156 = inst_4066;
var inst_4065__$1 = tmp4154;
var inst_4066__$1 = tmp4156;
var inst_4067__$1 = tmp4155;
var inst_4068__$1 = inst_4076;
var state_4124__$1 = (function (){var statearr_4160 = state_4124;
(statearr_4160[(12)] = inst_4065__$1);

(statearr_4160[(13)] = inst_4067__$1);

(statearr_4160[(17)] = inst_4075);

(statearr_4160[(15)] = inst_4066__$1);

(statearr_4160[(16)] = inst_4068__$1);

return statearr_4160;
})();
var statearr_4161_4195 = state_4124__$1;
(statearr_4161_4195[(2)] = null);

(statearr_4161_4195[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (18))){
var inst_4094 = (state_4124[(2)]);
var state_4124__$1 = state_4124;
var statearr_4162_4196 = state_4124__$1;
(statearr_4162_4196[(2)] = inst_4094);

(statearr_4162_4196[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4125 === (8))){
var inst_4067 = (state_4124[(13)]);
var inst_4068 = (state_4124[(16)]);
var inst_4070 = (inst_4068 < inst_4067);
var inst_4071 = inst_4070;
var state_4124__$1 = state_4124;
if(cljs.core.truth_(inst_4071)){
var statearr_4163_4197 = state_4124__$1;
(statearr_4163_4197[(1)] = (10));

} else {
var statearr_4164_4198 = state_4124__$1;
(statearr_4164_4198[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4170,mults,ensure_mult,p))
;
return ((function (switch__2842__auto__,c__2937__auto___4170,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4165 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4165[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4165[(1)] = (1));

return statearr_4165;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4124){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4124);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4166){if((e4166 instanceof Object)){
var ex__2846__auto__ = e4166;
var statearr_4167_4199 = state_4124;
(statearr_4167_4199[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4124);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4166;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4200 = state_4124;
state_4124 = G__4200;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4124){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4124);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4170,mults,ensure_mult,p))
})();
var state__2939__auto__ = (function (){var statearr_4168 = f__2938__auto__.call(null);
(statearr_4168[(6)] = c__2937__auto___4170);

return statearr_4168;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4170,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__4202 = arguments.length;
switch (G__4202) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__4205 = arguments.length;
switch (G__4205) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__4208 = arguments.length;
switch (G__4208) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__2937__auto___4275 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_4247){
var state_val_4248 = (state_4247[(1)]);
if((state_val_4248 === (7))){
var state_4247__$1 = state_4247;
var statearr_4249_4276 = state_4247__$1;
(statearr_4249_4276[(2)] = null);

(statearr_4249_4276[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (1))){
var state_4247__$1 = state_4247;
var statearr_4250_4277 = state_4247__$1;
(statearr_4250_4277[(2)] = null);

(statearr_4250_4277[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (4))){
var inst_4211 = (state_4247[(7)]);
var inst_4213 = (inst_4211 < cnt);
var state_4247__$1 = state_4247;
if(cljs.core.truth_(inst_4213)){
var statearr_4251_4278 = state_4247__$1;
(statearr_4251_4278[(1)] = (6));

} else {
var statearr_4252_4279 = state_4247__$1;
(statearr_4252_4279[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (15))){
var inst_4243 = (state_4247[(2)]);
var state_4247__$1 = state_4247;
var statearr_4253_4280 = state_4247__$1;
(statearr_4253_4280[(2)] = inst_4243);

(statearr_4253_4280[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (13))){
var inst_4236 = cljs.core.async.close_BANG_.call(null,out);
var state_4247__$1 = state_4247;
var statearr_4254_4281 = state_4247__$1;
(statearr_4254_4281[(2)] = inst_4236);

(statearr_4254_4281[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (6))){
var state_4247__$1 = state_4247;
var statearr_4255_4282 = state_4247__$1;
(statearr_4255_4282[(2)] = null);

(statearr_4255_4282[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (3))){
var inst_4245 = (state_4247[(2)]);
var state_4247__$1 = state_4247;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4247__$1,inst_4245);
} else {
if((state_val_4248 === (12))){
var inst_4233 = (state_4247[(8)]);
var inst_4233__$1 = (state_4247[(2)]);
var inst_4234 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_4233__$1);
var state_4247__$1 = (function (){var statearr_4256 = state_4247;
(statearr_4256[(8)] = inst_4233__$1);

return statearr_4256;
})();
if(cljs.core.truth_(inst_4234)){
var statearr_4257_4283 = state_4247__$1;
(statearr_4257_4283[(1)] = (13));

} else {
var statearr_4258_4284 = state_4247__$1;
(statearr_4258_4284[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (2))){
var inst_4210 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_4211 = (0);
var state_4247__$1 = (function (){var statearr_4259 = state_4247;
(statearr_4259[(7)] = inst_4211);

(statearr_4259[(9)] = inst_4210);

return statearr_4259;
})();
var statearr_4260_4285 = state_4247__$1;
(statearr_4260_4285[(2)] = null);

(statearr_4260_4285[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (11))){
var inst_4211 = (state_4247[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_4247,(10),Object,null,(9));
var inst_4220 = chs__$1.call(null,inst_4211);
var inst_4221 = done.call(null,inst_4211);
var inst_4222 = cljs.core.async.take_BANG_.call(null,inst_4220,inst_4221);
var state_4247__$1 = state_4247;
var statearr_4261_4286 = state_4247__$1;
(statearr_4261_4286[(2)] = inst_4222);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4247__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (9))){
var inst_4211 = (state_4247[(7)]);
var inst_4224 = (state_4247[(2)]);
var inst_4225 = (inst_4211 + (1));
var inst_4211__$1 = inst_4225;
var state_4247__$1 = (function (){var statearr_4262 = state_4247;
(statearr_4262[(10)] = inst_4224);

(statearr_4262[(7)] = inst_4211__$1);

return statearr_4262;
})();
var statearr_4263_4287 = state_4247__$1;
(statearr_4263_4287[(2)] = null);

(statearr_4263_4287[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (5))){
var inst_4231 = (state_4247[(2)]);
var state_4247__$1 = (function (){var statearr_4264 = state_4247;
(statearr_4264[(11)] = inst_4231);

return statearr_4264;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4247__$1,(12),dchan);
} else {
if((state_val_4248 === (14))){
var inst_4233 = (state_4247[(8)]);
var inst_4238 = cljs.core.apply.call(null,f,inst_4233);
var state_4247__$1 = state_4247;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4247__$1,(16),out,inst_4238);
} else {
if((state_val_4248 === (16))){
var inst_4240 = (state_4247[(2)]);
var state_4247__$1 = (function (){var statearr_4265 = state_4247;
(statearr_4265[(12)] = inst_4240);

return statearr_4265;
})();
var statearr_4266_4288 = state_4247__$1;
(statearr_4266_4288[(2)] = null);

(statearr_4266_4288[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (10))){
var inst_4215 = (state_4247[(2)]);
var inst_4216 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_4247__$1 = (function (){var statearr_4267 = state_4247;
(statearr_4267[(13)] = inst_4215);

return statearr_4267;
})();
var statearr_4268_4289 = state_4247__$1;
(statearr_4268_4289[(2)] = inst_4216);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4247__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4248 === (8))){
var inst_4229 = (state_4247[(2)]);
var state_4247__$1 = state_4247;
var statearr_4269_4290 = state_4247__$1;
(statearr_4269_4290[(2)] = inst_4229);

(statearr_4269_4290[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__2842__auto__,c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4270 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4270[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4270[(1)] = (1));

return statearr_4270;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4247){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4247);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4271){if((e4271 instanceof Object)){
var ex__2846__auto__ = e4271;
var statearr_4272_4291 = state_4247;
(statearr_4272_4291[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4247);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4271;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4292 = state_4247;
state_4247 = G__4292;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4247){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4247);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__2939__auto__ = (function (){var statearr_4273 = f__2938__auto__.call(null);
(statearr_4273[(6)] = c__2937__auto___4275);

return statearr_4273;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4275,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__4295 = arguments.length;
switch (G__4295) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4349 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4349,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4349,out){
return (function (state_4327){
var state_val_4328 = (state_4327[(1)]);
if((state_val_4328 === (7))){
var inst_4306 = (state_4327[(7)]);
var inst_4307 = (state_4327[(8)]);
var inst_4306__$1 = (state_4327[(2)]);
var inst_4307__$1 = cljs.core.nth.call(null,inst_4306__$1,(0),null);
var inst_4308 = cljs.core.nth.call(null,inst_4306__$1,(1),null);
var inst_4309 = (inst_4307__$1 == null);
var state_4327__$1 = (function (){var statearr_4329 = state_4327;
(statearr_4329[(9)] = inst_4308);

(statearr_4329[(7)] = inst_4306__$1);

(statearr_4329[(8)] = inst_4307__$1);

return statearr_4329;
})();
if(cljs.core.truth_(inst_4309)){
var statearr_4330_4350 = state_4327__$1;
(statearr_4330_4350[(1)] = (8));

} else {
var statearr_4331_4351 = state_4327__$1;
(statearr_4331_4351[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (1))){
var inst_4296 = cljs.core.vec.call(null,chs);
var inst_4297 = inst_4296;
var state_4327__$1 = (function (){var statearr_4332 = state_4327;
(statearr_4332[(10)] = inst_4297);

return statearr_4332;
})();
var statearr_4333_4352 = state_4327__$1;
(statearr_4333_4352[(2)] = null);

(statearr_4333_4352[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (4))){
var inst_4297 = (state_4327[(10)]);
var state_4327__$1 = state_4327;
return cljs.core.async.ioc_alts_BANG_.call(null,state_4327__$1,(7),inst_4297);
} else {
if((state_val_4328 === (6))){
var inst_4323 = (state_4327[(2)]);
var state_4327__$1 = state_4327;
var statearr_4334_4353 = state_4327__$1;
(statearr_4334_4353[(2)] = inst_4323);

(statearr_4334_4353[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (3))){
var inst_4325 = (state_4327[(2)]);
var state_4327__$1 = state_4327;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4327__$1,inst_4325);
} else {
if((state_val_4328 === (2))){
var inst_4297 = (state_4327[(10)]);
var inst_4299 = cljs.core.count.call(null,inst_4297);
var inst_4300 = (inst_4299 > (0));
var state_4327__$1 = state_4327;
if(cljs.core.truth_(inst_4300)){
var statearr_4336_4354 = state_4327__$1;
(statearr_4336_4354[(1)] = (4));

} else {
var statearr_4337_4355 = state_4327__$1;
(statearr_4337_4355[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (11))){
var inst_4297 = (state_4327[(10)]);
var inst_4316 = (state_4327[(2)]);
var tmp4335 = inst_4297;
var inst_4297__$1 = tmp4335;
var state_4327__$1 = (function (){var statearr_4338 = state_4327;
(statearr_4338[(11)] = inst_4316);

(statearr_4338[(10)] = inst_4297__$1);

return statearr_4338;
})();
var statearr_4339_4356 = state_4327__$1;
(statearr_4339_4356[(2)] = null);

(statearr_4339_4356[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (9))){
var inst_4307 = (state_4327[(8)]);
var state_4327__$1 = state_4327;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4327__$1,(11),out,inst_4307);
} else {
if((state_val_4328 === (5))){
var inst_4321 = cljs.core.async.close_BANG_.call(null,out);
var state_4327__$1 = state_4327;
var statearr_4340_4357 = state_4327__$1;
(statearr_4340_4357[(2)] = inst_4321);

(statearr_4340_4357[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (10))){
var inst_4319 = (state_4327[(2)]);
var state_4327__$1 = state_4327;
var statearr_4341_4358 = state_4327__$1;
(statearr_4341_4358[(2)] = inst_4319);

(statearr_4341_4358[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4328 === (8))){
var inst_4308 = (state_4327[(9)]);
var inst_4297 = (state_4327[(10)]);
var inst_4306 = (state_4327[(7)]);
var inst_4307 = (state_4327[(8)]);
var inst_4311 = (function (){var cs = inst_4297;
var vec__4302 = inst_4306;
var v = inst_4307;
var c = inst_4308;
return ((function (cs,vec__4302,v,c,inst_4308,inst_4297,inst_4306,inst_4307,state_val_4328,c__2937__auto___4349,out){
return (function (p1__4293_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__4293_SHARP_);
});
;})(cs,vec__4302,v,c,inst_4308,inst_4297,inst_4306,inst_4307,state_val_4328,c__2937__auto___4349,out))
})();
var inst_4312 = cljs.core.filterv.call(null,inst_4311,inst_4297);
var inst_4297__$1 = inst_4312;
var state_4327__$1 = (function (){var statearr_4342 = state_4327;
(statearr_4342[(10)] = inst_4297__$1);

return statearr_4342;
})();
var statearr_4343_4359 = state_4327__$1;
(statearr_4343_4359[(2)] = null);

(statearr_4343_4359[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4349,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4349,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4344 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4344[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4344[(1)] = (1));

return statearr_4344;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4327){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4327);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4345){if((e4345 instanceof Object)){
var ex__2846__auto__ = e4345;
var statearr_4346_4360 = state_4327;
(statearr_4346_4360[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4327);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4345;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4361 = state_4327;
state_4327 = G__4361;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4327){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4327);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4349,out))
})();
var state__2939__auto__ = (function (){var statearr_4347 = f__2938__auto__.call(null);
(statearr_4347[(6)] = c__2937__auto___4349);

return statearr_4347;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4349,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__4363 = arguments.length;
switch (G__4363) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4408 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4408,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4408,out){
return (function (state_4387){
var state_val_4388 = (state_4387[(1)]);
if((state_val_4388 === (7))){
var inst_4369 = (state_4387[(7)]);
var inst_4369__$1 = (state_4387[(2)]);
var inst_4370 = (inst_4369__$1 == null);
var inst_4371 = cljs.core.not.call(null,inst_4370);
var state_4387__$1 = (function (){var statearr_4389 = state_4387;
(statearr_4389[(7)] = inst_4369__$1);

return statearr_4389;
})();
if(inst_4371){
var statearr_4390_4409 = state_4387__$1;
(statearr_4390_4409[(1)] = (8));

} else {
var statearr_4391_4410 = state_4387__$1;
(statearr_4391_4410[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (1))){
var inst_4364 = (0);
var state_4387__$1 = (function (){var statearr_4392 = state_4387;
(statearr_4392[(8)] = inst_4364);

return statearr_4392;
})();
var statearr_4393_4411 = state_4387__$1;
(statearr_4393_4411[(2)] = null);

(statearr_4393_4411[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (4))){
var state_4387__$1 = state_4387;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4387__$1,(7),ch);
} else {
if((state_val_4388 === (6))){
var inst_4382 = (state_4387[(2)]);
var state_4387__$1 = state_4387;
var statearr_4394_4412 = state_4387__$1;
(statearr_4394_4412[(2)] = inst_4382);

(statearr_4394_4412[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (3))){
var inst_4384 = (state_4387[(2)]);
var inst_4385 = cljs.core.async.close_BANG_.call(null,out);
var state_4387__$1 = (function (){var statearr_4395 = state_4387;
(statearr_4395[(9)] = inst_4384);

return statearr_4395;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4387__$1,inst_4385);
} else {
if((state_val_4388 === (2))){
var inst_4364 = (state_4387[(8)]);
var inst_4366 = (inst_4364 < n);
var state_4387__$1 = state_4387;
if(cljs.core.truth_(inst_4366)){
var statearr_4396_4413 = state_4387__$1;
(statearr_4396_4413[(1)] = (4));

} else {
var statearr_4397_4414 = state_4387__$1;
(statearr_4397_4414[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (11))){
var inst_4364 = (state_4387[(8)]);
var inst_4374 = (state_4387[(2)]);
var inst_4375 = (inst_4364 + (1));
var inst_4364__$1 = inst_4375;
var state_4387__$1 = (function (){var statearr_4398 = state_4387;
(statearr_4398[(10)] = inst_4374);

(statearr_4398[(8)] = inst_4364__$1);

return statearr_4398;
})();
var statearr_4399_4415 = state_4387__$1;
(statearr_4399_4415[(2)] = null);

(statearr_4399_4415[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (9))){
var state_4387__$1 = state_4387;
var statearr_4400_4416 = state_4387__$1;
(statearr_4400_4416[(2)] = null);

(statearr_4400_4416[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (5))){
var state_4387__$1 = state_4387;
var statearr_4401_4417 = state_4387__$1;
(statearr_4401_4417[(2)] = null);

(statearr_4401_4417[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (10))){
var inst_4379 = (state_4387[(2)]);
var state_4387__$1 = state_4387;
var statearr_4402_4418 = state_4387__$1;
(statearr_4402_4418[(2)] = inst_4379);

(statearr_4402_4418[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4388 === (8))){
var inst_4369 = (state_4387[(7)]);
var state_4387__$1 = state_4387;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4387__$1,(11),out,inst_4369);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4408,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4408,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4403 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_4403[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4403[(1)] = (1));

return statearr_4403;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4387){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4387);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4404){if((e4404 instanceof Object)){
var ex__2846__auto__ = e4404;
var statearr_4405_4419 = state_4387;
(statearr_4405_4419[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4387);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4404;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4420 = state_4387;
state_4387 = G__4420;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4387){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4387);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4408,out))
})();
var state__2939__auto__ = (function (){var statearr_4406 = f__2938__auto__.call(null);
(statearr_4406[(6)] = c__2937__auto___4408);

return statearr_4406;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4408,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async4422 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4422 = (function (f,ch,meta4423){
this.f = f;
this.ch = ch;
this.meta4423 = meta4423;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_4424,meta4423__$1){
var self__ = this;
var _4424__$1 = this;
return (new cljs.core.async.t_cljs$core$async4422(self__.f,self__.ch,meta4423__$1));
});

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_4424){
var self__ = this;
var _4424__$1 = this;
return self__.meta4423;
});

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async4425 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4425 = (function (f,ch,meta4423,_,fn1,meta4426){
this.f = f;
this.ch = ch;
this.meta4423 = meta4423;
this._ = _;
this.fn1 = fn1;
this.meta4426 = meta4426;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_4427,meta4426__$1){
var self__ = this;
var _4427__$1 = this;
return (new cljs.core.async.t_cljs$core$async4425(self__.f,self__.ch,self__.meta4423,self__._,self__.fn1,meta4426__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_4427){
var self__ = this;
var _4427__$1 = this;
return self__.meta4426;
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__4421_SHARP_){
return f1.call(null,(((p1__4421_SHARP_ == null))?null:self__.f.call(null,p1__4421_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta4423","meta4423",-1403133041,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async4422","cljs.core.async/t_cljs$core$async4422",-1242558719,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta4426","meta4426",1494027371,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async4425.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4425.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4425";

cljs.core.async.t_cljs$core$async4425.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async4425");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4425.
 */
cljs.core.async.__GT_t_cljs$core$async4425 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async4425(f__$1,ch__$1,meta4423__$1,___$2,fn1__$1,meta4426){
return (new cljs.core.async.t_cljs$core$async4425(f__$1,ch__$1,meta4423__$1,___$2,fn1__$1,meta4426));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async4425(self__.f,self__.ch,self__.meta4423,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4036__auto__ = ret;
if(cljs.core.truth_(and__4036__auto__)){
return (!((cljs.core.deref.call(null,ret) == null)));
} else {
return and__4036__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4422.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async4422.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta4423","meta4423",-1403133041,null)], null);
});

cljs.core.async.t_cljs$core$async4422.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4422.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4422";

cljs.core.async.t_cljs$core$async4422.cljs$lang$ctorPrWriter = (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async4422");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4422.
 */
cljs.core.async.__GT_t_cljs$core$async4422 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async4422(f__$1,ch__$1,meta4423){
return (new cljs.core.async.t_cljs$core$async4422(f__$1,ch__$1,meta4423));
});

}

return (new cljs.core.async.t_cljs$core$async4422(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async4428 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4428 = (function (f,ch,meta4429){
this.f = f;
this.ch = ch;
this.meta4429 = meta4429;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_4430,meta4429__$1){
var self__ = this;
var _4430__$1 = this;
return (new cljs.core.async.t_cljs$core$async4428(self__.f,self__.ch,meta4429__$1));
});

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_4430){
var self__ = this;
var _4430__$1 = this;
return self__.meta4429;
});

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4428.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async4428.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta4429","meta4429",978821620,null)], null);
});

cljs.core.async.t_cljs$core$async4428.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4428.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4428";

cljs.core.async.t_cljs$core$async4428.cljs$lang$ctorPrWriter = (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async4428");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4428.
 */
cljs.core.async.__GT_t_cljs$core$async4428 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async4428(f__$1,ch__$1,meta4429){
return (new cljs.core.async.t_cljs$core$async4428(f__$1,ch__$1,meta4429));
});

}

return (new cljs.core.async.t_cljs$core$async4428(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async4431 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4431 = (function (p,ch,meta4432){
this.p = p;
this.ch = ch;
this.meta4432 = meta4432;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_4433,meta4432__$1){
var self__ = this;
var _4433__$1 = this;
return (new cljs.core.async.t_cljs$core$async4431(self__.p,self__.ch,meta4432__$1));
});

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_4433){
var self__ = this;
var _4433__$1 = this;
return self__.meta4432;
});

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4431.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async4431.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta4432","meta4432",-849309621,null)], null);
});

cljs.core.async.t_cljs$core$async4431.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4431.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4431";

cljs.core.async.t_cljs$core$async4431.cljs$lang$ctorPrWriter = (function (this__4290__auto__,writer__4291__auto__,opt__4292__auto__){
return cljs.core._write.call(null,writer__4291__auto__,"cljs.core.async/t_cljs$core$async4431");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4431.
 */
cljs.core.async.__GT_t_cljs$core$async4431 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async4431(p__$1,ch__$1,meta4432){
return (new cljs.core.async.t_cljs$core$async4431(p__$1,ch__$1,meta4432));
});

}

return (new cljs.core.async.t_cljs$core$async4431(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__4435 = arguments.length;
switch (G__4435) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4475 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4475,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4475,out){
return (function (state_4456){
var state_val_4457 = (state_4456[(1)]);
if((state_val_4457 === (7))){
var inst_4452 = (state_4456[(2)]);
var state_4456__$1 = state_4456;
var statearr_4458_4476 = state_4456__$1;
(statearr_4458_4476[(2)] = inst_4452);

(statearr_4458_4476[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (1))){
var state_4456__$1 = state_4456;
var statearr_4459_4477 = state_4456__$1;
(statearr_4459_4477[(2)] = null);

(statearr_4459_4477[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (4))){
var inst_4438 = (state_4456[(7)]);
var inst_4438__$1 = (state_4456[(2)]);
var inst_4439 = (inst_4438__$1 == null);
var state_4456__$1 = (function (){var statearr_4460 = state_4456;
(statearr_4460[(7)] = inst_4438__$1);

return statearr_4460;
})();
if(cljs.core.truth_(inst_4439)){
var statearr_4461_4478 = state_4456__$1;
(statearr_4461_4478[(1)] = (5));

} else {
var statearr_4462_4479 = state_4456__$1;
(statearr_4462_4479[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (6))){
var inst_4438 = (state_4456[(7)]);
var inst_4443 = p.call(null,inst_4438);
var state_4456__$1 = state_4456;
if(cljs.core.truth_(inst_4443)){
var statearr_4463_4480 = state_4456__$1;
(statearr_4463_4480[(1)] = (8));

} else {
var statearr_4464_4481 = state_4456__$1;
(statearr_4464_4481[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (3))){
var inst_4454 = (state_4456[(2)]);
var state_4456__$1 = state_4456;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4456__$1,inst_4454);
} else {
if((state_val_4457 === (2))){
var state_4456__$1 = state_4456;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4456__$1,(4),ch);
} else {
if((state_val_4457 === (11))){
var inst_4446 = (state_4456[(2)]);
var state_4456__$1 = state_4456;
var statearr_4465_4482 = state_4456__$1;
(statearr_4465_4482[(2)] = inst_4446);

(statearr_4465_4482[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (9))){
var state_4456__$1 = state_4456;
var statearr_4466_4483 = state_4456__$1;
(statearr_4466_4483[(2)] = null);

(statearr_4466_4483[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (5))){
var inst_4441 = cljs.core.async.close_BANG_.call(null,out);
var state_4456__$1 = state_4456;
var statearr_4467_4484 = state_4456__$1;
(statearr_4467_4484[(2)] = inst_4441);

(statearr_4467_4484[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (10))){
var inst_4449 = (state_4456[(2)]);
var state_4456__$1 = (function (){var statearr_4468 = state_4456;
(statearr_4468[(8)] = inst_4449);

return statearr_4468;
})();
var statearr_4469_4485 = state_4456__$1;
(statearr_4469_4485[(2)] = null);

(statearr_4469_4485[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4457 === (8))){
var inst_4438 = (state_4456[(7)]);
var state_4456__$1 = state_4456;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4456__$1,(11),out,inst_4438);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4475,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4475,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4470 = [null,null,null,null,null,null,null,null,null];
(statearr_4470[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4470[(1)] = (1));

return statearr_4470;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4456){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4456);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4471){if((e4471 instanceof Object)){
var ex__2846__auto__ = e4471;
var statearr_4472_4486 = state_4456;
(statearr_4472_4486[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4456);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4471;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4487 = state_4456;
state_4456 = G__4487;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4456){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4456);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4475,out))
})();
var state__2939__auto__ = (function (){var statearr_4473 = f__2938__auto__.call(null);
(statearr_4473[(6)] = c__2937__auto___4475);

return statearr_4473;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4475,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__4489 = arguments.length;
switch (G__4489) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__2937__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto__){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto__){
return (function (state_4552){
var state_val_4553 = (state_4552[(1)]);
if((state_val_4553 === (7))){
var inst_4548 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
var statearr_4554_4592 = state_4552__$1;
(statearr_4554_4592[(2)] = inst_4548);

(statearr_4554_4592[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (20))){
var inst_4518 = (state_4552[(7)]);
var inst_4529 = (state_4552[(2)]);
var inst_4530 = cljs.core.next.call(null,inst_4518);
var inst_4504 = inst_4530;
var inst_4505 = null;
var inst_4506 = (0);
var inst_4507 = (0);
var state_4552__$1 = (function (){var statearr_4555 = state_4552;
(statearr_4555[(8)] = inst_4507);

(statearr_4555[(9)] = inst_4529);

(statearr_4555[(10)] = inst_4506);

(statearr_4555[(11)] = inst_4504);

(statearr_4555[(12)] = inst_4505);

return statearr_4555;
})();
var statearr_4556_4593 = state_4552__$1;
(statearr_4556_4593[(2)] = null);

(statearr_4556_4593[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (1))){
var state_4552__$1 = state_4552;
var statearr_4557_4594 = state_4552__$1;
(statearr_4557_4594[(2)] = null);

(statearr_4557_4594[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (4))){
var inst_4493 = (state_4552[(13)]);
var inst_4493__$1 = (state_4552[(2)]);
var inst_4494 = (inst_4493__$1 == null);
var state_4552__$1 = (function (){var statearr_4558 = state_4552;
(statearr_4558[(13)] = inst_4493__$1);

return statearr_4558;
})();
if(cljs.core.truth_(inst_4494)){
var statearr_4559_4595 = state_4552__$1;
(statearr_4559_4595[(1)] = (5));

} else {
var statearr_4560_4596 = state_4552__$1;
(statearr_4560_4596[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (15))){
var state_4552__$1 = state_4552;
var statearr_4564_4597 = state_4552__$1;
(statearr_4564_4597[(2)] = null);

(statearr_4564_4597[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (21))){
var state_4552__$1 = state_4552;
var statearr_4565_4598 = state_4552__$1;
(statearr_4565_4598[(2)] = null);

(statearr_4565_4598[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (13))){
var inst_4507 = (state_4552[(8)]);
var inst_4506 = (state_4552[(10)]);
var inst_4504 = (state_4552[(11)]);
var inst_4505 = (state_4552[(12)]);
var inst_4514 = (state_4552[(2)]);
var inst_4515 = (inst_4507 + (1));
var tmp4561 = inst_4506;
var tmp4562 = inst_4504;
var tmp4563 = inst_4505;
var inst_4504__$1 = tmp4562;
var inst_4505__$1 = tmp4563;
var inst_4506__$1 = tmp4561;
var inst_4507__$1 = inst_4515;
var state_4552__$1 = (function (){var statearr_4566 = state_4552;
(statearr_4566[(8)] = inst_4507__$1);

(statearr_4566[(10)] = inst_4506__$1);

(statearr_4566[(14)] = inst_4514);

(statearr_4566[(11)] = inst_4504__$1);

(statearr_4566[(12)] = inst_4505__$1);

return statearr_4566;
})();
var statearr_4567_4599 = state_4552__$1;
(statearr_4567_4599[(2)] = null);

(statearr_4567_4599[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (22))){
var state_4552__$1 = state_4552;
var statearr_4568_4600 = state_4552__$1;
(statearr_4568_4600[(2)] = null);

(statearr_4568_4600[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (6))){
var inst_4493 = (state_4552[(13)]);
var inst_4502 = f.call(null,inst_4493);
var inst_4503 = cljs.core.seq.call(null,inst_4502);
var inst_4504 = inst_4503;
var inst_4505 = null;
var inst_4506 = (0);
var inst_4507 = (0);
var state_4552__$1 = (function (){var statearr_4569 = state_4552;
(statearr_4569[(8)] = inst_4507);

(statearr_4569[(10)] = inst_4506);

(statearr_4569[(11)] = inst_4504);

(statearr_4569[(12)] = inst_4505);

return statearr_4569;
})();
var statearr_4570_4601 = state_4552__$1;
(statearr_4570_4601[(2)] = null);

(statearr_4570_4601[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (17))){
var inst_4518 = (state_4552[(7)]);
var inst_4522 = cljs.core.chunk_first.call(null,inst_4518);
var inst_4523 = cljs.core.chunk_rest.call(null,inst_4518);
var inst_4524 = cljs.core.count.call(null,inst_4522);
var inst_4504 = inst_4523;
var inst_4505 = inst_4522;
var inst_4506 = inst_4524;
var inst_4507 = (0);
var state_4552__$1 = (function (){var statearr_4571 = state_4552;
(statearr_4571[(8)] = inst_4507);

(statearr_4571[(10)] = inst_4506);

(statearr_4571[(11)] = inst_4504);

(statearr_4571[(12)] = inst_4505);

return statearr_4571;
})();
var statearr_4572_4602 = state_4552__$1;
(statearr_4572_4602[(2)] = null);

(statearr_4572_4602[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (3))){
var inst_4550 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4552__$1,inst_4550);
} else {
if((state_val_4553 === (12))){
var inst_4538 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
var statearr_4573_4603 = state_4552__$1;
(statearr_4573_4603[(2)] = inst_4538);

(statearr_4573_4603[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (2))){
var state_4552__$1 = state_4552;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4552__$1,(4),in$);
} else {
if((state_val_4553 === (23))){
var inst_4546 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
var statearr_4574_4604 = state_4552__$1;
(statearr_4574_4604[(2)] = inst_4546);

(statearr_4574_4604[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (19))){
var inst_4533 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
var statearr_4575_4605 = state_4552__$1;
(statearr_4575_4605[(2)] = inst_4533);

(statearr_4575_4605[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (11))){
var inst_4518 = (state_4552[(7)]);
var inst_4504 = (state_4552[(11)]);
var inst_4518__$1 = cljs.core.seq.call(null,inst_4504);
var state_4552__$1 = (function (){var statearr_4576 = state_4552;
(statearr_4576[(7)] = inst_4518__$1);

return statearr_4576;
})();
if(inst_4518__$1){
var statearr_4577_4606 = state_4552__$1;
(statearr_4577_4606[(1)] = (14));

} else {
var statearr_4578_4607 = state_4552__$1;
(statearr_4578_4607[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (9))){
var inst_4540 = (state_4552[(2)]);
var inst_4541 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_4552__$1 = (function (){var statearr_4579 = state_4552;
(statearr_4579[(15)] = inst_4540);

return statearr_4579;
})();
if(cljs.core.truth_(inst_4541)){
var statearr_4580_4608 = state_4552__$1;
(statearr_4580_4608[(1)] = (21));

} else {
var statearr_4581_4609 = state_4552__$1;
(statearr_4581_4609[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (5))){
var inst_4496 = cljs.core.async.close_BANG_.call(null,out);
var state_4552__$1 = state_4552;
var statearr_4582_4610 = state_4552__$1;
(statearr_4582_4610[(2)] = inst_4496);

(statearr_4582_4610[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (14))){
var inst_4518 = (state_4552[(7)]);
var inst_4520 = cljs.core.chunked_seq_QMARK_.call(null,inst_4518);
var state_4552__$1 = state_4552;
if(inst_4520){
var statearr_4583_4611 = state_4552__$1;
(statearr_4583_4611[(1)] = (17));

} else {
var statearr_4584_4612 = state_4552__$1;
(statearr_4584_4612[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (16))){
var inst_4536 = (state_4552[(2)]);
var state_4552__$1 = state_4552;
var statearr_4585_4613 = state_4552__$1;
(statearr_4585_4613[(2)] = inst_4536);

(statearr_4585_4613[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4553 === (10))){
var inst_4507 = (state_4552[(8)]);
var inst_4505 = (state_4552[(12)]);
var inst_4512 = cljs.core._nth.call(null,inst_4505,inst_4507);
var state_4552__$1 = state_4552;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4552__$1,(13),out,inst_4512);
} else {
if((state_val_4553 === (18))){
var inst_4518 = (state_4552[(7)]);
var inst_4527 = cljs.core.first.call(null,inst_4518);
var state_4552__$1 = state_4552;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4552__$1,(20),out,inst_4527);
} else {
if((state_val_4553 === (8))){
var inst_4507 = (state_4552[(8)]);
var inst_4506 = (state_4552[(10)]);
var inst_4509 = (inst_4507 < inst_4506);
var inst_4510 = inst_4509;
var state_4552__$1 = state_4552;
if(cljs.core.truth_(inst_4510)){
var statearr_4586_4614 = state_4552__$1;
(statearr_4586_4614[(1)] = (10));

} else {
var statearr_4587_4615 = state_4552__$1;
(statearr_4587_4615[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto__))
;
return ((function (switch__2842__auto__,c__2937__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____0 = (function (){
var statearr_4588 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4588[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__);

(statearr_4588[(1)] = (1));

return statearr_4588;
});
var cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____1 = (function (state_4552){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4552);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4589){if((e4589 instanceof Object)){
var ex__2846__auto__ = e4589;
var statearr_4590_4616 = state_4552;
(statearr_4590_4616[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4552);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4589;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4617 = state_4552;
state_4552 = G__4617;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__ = function(state_4552){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____1.call(this,state_4552);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__2843__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto__))
})();
var state__2939__auto__ = (function (){var statearr_4591 = f__2938__auto__.call(null);
(statearr_4591[(6)] = c__2937__auto__);

return statearr_4591;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto__))
);

return c__2937__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__4619 = arguments.length;
switch (G__4619) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__4622 = arguments.length;
switch (G__4622) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__4625 = arguments.length;
switch (G__4625) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4672 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4672,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4672,out){
return (function (state_4649){
var state_val_4650 = (state_4649[(1)]);
if((state_val_4650 === (7))){
var inst_4644 = (state_4649[(2)]);
var state_4649__$1 = state_4649;
var statearr_4651_4673 = state_4649__$1;
(statearr_4651_4673[(2)] = inst_4644);

(statearr_4651_4673[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (1))){
var inst_4626 = null;
var state_4649__$1 = (function (){var statearr_4652 = state_4649;
(statearr_4652[(7)] = inst_4626);

return statearr_4652;
})();
var statearr_4653_4674 = state_4649__$1;
(statearr_4653_4674[(2)] = null);

(statearr_4653_4674[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (4))){
var inst_4629 = (state_4649[(8)]);
var inst_4629__$1 = (state_4649[(2)]);
var inst_4630 = (inst_4629__$1 == null);
var inst_4631 = cljs.core.not.call(null,inst_4630);
var state_4649__$1 = (function (){var statearr_4654 = state_4649;
(statearr_4654[(8)] = inst_4629__$1);

return statearr_4654;
})();
if(inst_4631){
var statearr_4655_4675 = state_4649__$1;
(statearr_4655_4675[(1)] = (5));

} else {
var statearr_4656_4676 = state_4649__$1;
(statearr_4656_4676[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (6))){
var state_4649__$1 = state_4649;
var statearr_4657_4677 = state_4649__$1;
(statearr_4657_4677[(2)] = null);

(statearr_4657_4677[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (3))){
var inst_4646 = (state_4649[(2)]);
var inst_4647 = cljs.core.async.close_BANG_.call(null,out);
var state_4649__$1 = (function (){var statearr_4658 = state_4649;
(statearr_4658[(9)] = inst_4646);

return statearr_4658;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4649__$1,inst_4647);
} else {
if((state_val_4650 === (2))){
var state_4649__$1 = state_4649;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4649__$1,(4),ch);
} else {
if((state_val_4650 === (11))){
var inst_4629 = (state_4649[(8)]);
var inst_4638 = (state_4649[(2)]);
var inst_4626 = inst_4629;
var state_4649__$1 = (function (){var statearr_4659 = state_4649;
(statearr_4659[(10)] = inst_4638);

(statearr_4659[(7)] = inst_4626);

return statearr_4659;
})();
var statearr_4660_4678 = state_4649__$1;
(statearr_4660_4678[(2)] = null);

(statearr_4660_4678[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (9))){
var inst_4629 = (state_4649[(8)]);
var state_4649__$1 = state_4649;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4649__$1,(11),out,inst_4629);
} else {
if((state_val_4650 === (5))){
var inst_4629 = (state_4649[(8)]);
var inst_4626 = (state_4649[(7)]);
var inst_4633 = cljs.core._EQ_.call(null,inst_4629,inst_4626);
var state_4649__$1 = state_4649;
if(inst_4633){
var statearr_4662_4679 = state_4649__$1;
(statearr_4662_4679[(1)] = (8));

} else {
var statearr_4663_4680 = state_4649__$1;
(statearr_4663_4680[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (10))){
var inst_4641 = (state_4649[(2)]);
var state_4649__$1 = state_4649;
var statearr_4664_4681 = state_4649__$1;
(statearr_4664_4681[(2)] = inst_4641);

(statearr_4664_4681[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4650 === (8))){
var inst_4626 = (state_4649[(7)]);
var tmp4661 = inst_4626;
var inst_4626__$1 = tmp4661;
var state_4649__$1 = (function (){var statearr_4665 = state_4649;
(statearr_4665[(7)] = inst_4626__$1);

return statearr_4665;
})();
var statearr_4666_4682 = state_4649__$1;
(statearr_4666_4682[(2)] = null);

(statearr_4666_4682[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4672,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4672,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4667 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_4667[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4667[(1)] = (1));

return statearr_4667;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4649){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4649);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4668){if((e4668 instanceof Object)){
var ex__2846__auto__ = e4668;
var statearr_4669_4683 = state_4649;
(statearr_4669_4683[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4649);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4668;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4684 = state_4649;
state_4649 = G__4684;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4649){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4649);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4672,out))
})();
var state__2939__auto__ = (function (){var statearr_4670 = f__2938__auto__.call(null);
(statearr_4670[(6)] = c__2937__auto___4672);

return statearr_4670;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4672,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__4686 = arguments.length;
switch (G__4686) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4752 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4752,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4752,out){
return (function (state_4724){
var state_val_4725 = (state_4724[(1)]);
if((state_val_4725 === (7))){
var inst_4720 = (state_4724[(2)]);
var state_4724__$1 = state_4724;
var statearr_4726_4753 = state_4724__$1;
(statearr_4726_4753[(2)] = inst_4720);

(statearr_4726_4753[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (1))){
var inst_4687 = (new Array(n));
var inst_4688 = inst_4687;
var inst_4689 = (0);
var state_4724__$1 = (function (){var statearr_4727 = state_4724;
(statearr_4727[(7)] = inst_4688);

(statearr_4727[(8)] = inst_4689);

return statearr_4727;
})();
var statearr_4728_4754 = state_4724__$1;
(statearr_4728_4754[(2)] = null);

(statearr_4728_4754[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (4))){
var inst_4692 = (state_4724[(9)]);
var inst_4692__$1 = (state_4724[(2)]);
var inst_4693 = (inst_4692__$1 == null);
var inst_4694 = cljs.core.not.call(null,inst_4693);
var state_4724__$1 = (function (){var statearr_4729 = state_4724;
(statearr_4729[(9)] = inst_4692__$1);

return statearr_4729;
})();
if(inst_4694){
var statearr_4730_4755 = state_4724__$1;
(statearr_4730_4755[(1)] = (5));

} else {
var statearr_4731_4756 = state_4724__$1;
(statearr_4731_4756[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (15))){
var inst_4714 = (state_4724[(2)]);
var state_4724__$1 = state_4724;
var statearr_4732_4757 = state_4724__$1;
(statearr_4732_4757[(2)] = inst_4714);

(statearr_4732_4757[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (13))){
var state_4724__$1 = state_4724;
var statearr_4733_4758 = state_4724__$1;
(statearr_4733_4758[(2)] = null);

(statearr_4733_4758[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (6))){
var inst_4689 = (state_4724[(8)]);
var inst_4710 = (inst_4689 > (0));
var state_4724__$1 = state_4724;
if(cljs.core.truth_(inst_4710)){
var statearr_4734_4759 = state_4724__$1;
(statearr_4734_4759[(1)] = (12));

} else {
var statearr_4735_4760 = state_4724__$1;
(statearr_4735_4760[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (3))){
var inst_4722 = (state_4724[(2)]);
var state_4724__$1 = state_4724;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4724__$1,inst_4722);
} else {
if((state_val_4725 === (12))){
var inst_4688 = (state_4724[(7)]);
var inst_4712 = cljs.core.vec.call(null,inst_4688);
var state_4724__$1 = state_4724;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4724__$1,(15),out,inst_4712);
} else {
if((state_val_4725 === (2))){
var state_4724__$1 = state_4724;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4724__$1,(4),ch);
} else {
if((state_val_4725 === (11))){
var inst_4704 = (state_4724[(2)]);
var inst_4705 = (new Array(n));
var inst_4688 = inst_4705;
var inst_4689 = (0);
var state_4724__$1 = (function (){var statearr_4736 = state_4724;
(statearr_4736[(10)] = inst_4704);

(statearr_4736[(7)] = inst_4688);

(statearr_4736[(8)] = inst_4689);

return statearr_4736;
})();
var statearr_4737_4761 = state_4724__$1;
(statearr_4737_4761[(2)] = null);

(statearr_4737_4761[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (9))){
var inst_4688 = (state_4724[(7)]);
var inst_4702 = cljs.core.vec.call(null,inst_4688);
var state_4724__$1 = state_4724;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4724__$1,(11),out,inst_4702);
} else {
if((state_val_4725 === (5))){
var inst_4688 = (state_4724[(7)]);
var inst_4692 = (state_4724[(9)]);
var inst_4689 = (state_4724[(8)]);
var inst_4697 = (state_4724[(11)]);
var inst_4696 = (inst_4688[inst_4689] = inst_4692);
var inst_4697__$1 = (inst_4689 + (1));
var inst_4698 = (inst_4697__$1 < n);
var state_4724__$1 = (function (){var statearr_4738 = state_4724;
(statearr_4738[(12)] = inst_4696);

(statearr_4738[(11)] = inst_4697__$1);

return statearr_4738;
})();
if(cljs.core.truth_(inst_4698)){
var statearr_4739_4762 = state_4724__$1;
(statearr_4739_4762[(1)] = (8));

} else {
var statearr_4740_4763 = state_4724__$1;
(statearr_4740_4763[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (14))){
var inst_4717 = (state_4724[(2)]);
var inst_4718 = cljs.core.async.close_BANG_.call(null,out);
var state_4724__$1 = (function (){var statearr_4742 = state_4724;
(statearr_4742[(13)] = inst_4717);

return statearr_4742;
})();
var statearr_4743_4764 = state_4724__$1;
(statearr_4743_4764[(2)] = inst_4718);

(statearr_4743_4764[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (10))){
var inst_4708 = (state_4724[(2)]);
var state_4724__$1 = state_4724;
var statearr_4744_4765 = state_4724__$1;
(statearr_4744_4765[(2)] = inst_4708);

(statearr_4744_4765[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4725 === (8))){
var inst_4688 = (state_4724[(7)]);
var inst_4697 = (state_4724[(11)]);
var tmp4741 = inst_4688;
var inst_4688__$1 = tmp4741;
var inst_4689 = inst_4697;
var state_4724__$1 = (function (){var statearr_4745 = state_4724;
(statearr_4745[(7)] = inst_4688__$1);

(statearr_4745[(8)] = inst_4689);

return statearr_4745;
})();
var statearr_4746_4766 = state_4724__$1;
(statearr_4746_4766[(2)] = null);

(statearr_4746_4766[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4752,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4752,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4747 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4747[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4747[(1)] = (1));

return statearr_4747;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4724){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4724);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4748){if((e4748 instanceof Object)){
var ex__2846__auto__ = e4748;
var statearr_4749_4767 = state_4724;
(statearr_4749_4767[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4724);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4748;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4768 = state_4724;
state_4724 = G__4768;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4724){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4724);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4752,out))
})();
var state__2939__auto__ = (function (){var statearr_4750 = f__2938__auto__.call(null);
(statearr_4750[(6)] = c__2937__auto___4752);

return statearr_4750;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4752,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__4770 = arguments.length;
switch (G__4770) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__2937__auto___4840 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__2937__auto___4840,out){
return (function (){
var f__2938__auto__ = (function (){var switch__2842__auto__ = ((function (c__2937__auto___4840,out){
return (function (state_4812){
var state_val_4813 = (state_4812[(1)]);
if((state_val_4813 === (7))){
var inst_4808 = (state_4812[(2)]);
var state_4812__$1 = state_4812;
var statearr_4814_4841 = state_4812__$1;
(statearr_4814_4841[(2)] = inst_4808);

(statearr_4814_4841[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (1))){
var inst_4771 = [];
var inst_4772 = inst_4771;
var inst_4773 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_4812__$1 = (function (){var statearr_4815 = state_4812;
(statearr_4815[(7)] = inst_4773);

(statearr_4815[(8)] = inst_4772);

return statearr_4815;
})();
var statearr_4816_4842 = state_4812__$1;
(statearr_4816_4842[(2)] = null);

(statearr_4816_4842[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (4))){
var inst_4776 = (state_4812[(9)]);
var inst_4776__$1 = (state_4812[(2)]);
var inst_4777 = (inst_4776__$1 == null);
var inst_4778 = cljs.core.not.call(null,inst_4777);
var state_4812__$1 = (function (){var statearr_4817 = state_4812;
(statearr_4817[(9)] = inst_4776__$1);

return statearr_4817;
})();
if(inst_4778){
var statearr_4818_4843 = state_4812__$1;
(statearr_4818_4843[(1)] = (5));

} else {
var statearr_4819_4844 = state_4812__$1;
(statearr_4819_4844[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (15))){
var inst_4802 = (state_4812[(2)]);
var state_4812__$1 = state_4812;
var statearr_4820_4845 = state_4812__$1;
(statearr_4820_4845[(2)] = inst_4802);

(statearr_4820_4845[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (13))){
var state_4812__$1 = state_4812;
var statearr_4821_4846 = state_4812__$1;
(statearr_4821_4846[(2)] = null);

(statearr_4821_4846[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (6))){
var inst_4772 = (state_4812[(8)]);
var inst_4797 = inst_4772.length;
var inst_4798 = (inst_4797 > (0));
var state_4812__$1 = state_4812;
if(cljs.core.truth_(inst_4798)){
var statearr_4822_4847 = state_4812__$1;
(statearr_4822_4847[(1)] = (12));

} else {
var statearr_4823_4848 = state_4812__$1;
(statearr_4823_4848[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (3))){
var inst_4810 = (state_4812[(2)]);
var state_4812__$1 = state_4812;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4812__$1,inst_4810);
} else {
if((state_val_4813 === (12))){
var inst_4772 = (state_4812[(8)]);
var inst_4800 = cljs.core.vec.call(null,inst_4772);
var state_4812__$1 = state_4812;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4812__$1,(15),out,inst_4800);
} else {
if((state_val_4813 === (2))){
var state_4812__$1 = state_4812;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4812__$1,(4),ch);
} else {
if((state_val_4813 === (11))){
var inst_4776 = (state_4812[(9)]);
var inst_4780 = (state_4812[(10)]);
var inst_4790 = (state_4812[(2)]);
var inst_4791 = [];
var inst_4792 = inst_4791.push(inst_4776);
var inst_4772 = inst_4791;
var inst_4773 = inst_4780;
var state_4812__$1 = (function (){var statearr_4824 = state_4812;
(statearr_4824[(7)] = inst_4773);

(statearr_4824[(8)] = inst_4772);

(statearr_4824[(11)] = inst_4792);

(statearr_4824[(12)] = inst_4790);

return statearr_4824;
})();
var statearr_4825_4849 = state_4812__$1;
(statearr_4825_4849[(2)] = null);

(statearr_4825_4849[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (9))){
var inst_4772 = (state_4812[(8)]);
var inst_4788 = cljs.core.vec.call(null,inst_4772);
var state_4812__$1 = state_4812;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4812__$1,(11),out,inst_4788);
} else {
if((state_val_4813 === (5))){
var inst_4773 = (state_4812[(7)]);
var inst_4776 = (state_4812[(9)]);
var inst_4780 = (state_4812[(10)]);
var inst_4780__$1 = f.call(null,inst_4776);
var inst_4781 = cljs.core._EQ_.call(null,inst_4780__$1,inst_4773);
var inst_4782 = cljs.core.keyword_identical_QMARK_.call(null,inst_4773,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_4783 = ((inst_4781) || (inst_4782));
var state_4812__$1 = (function (){var statearr_4826 = state_4812;
(statearr_4826[(10)] = inst_4780__$1);

return statearr_4826;
})();
if(cljs.core.truth_(inst_4783)){
var statearr_4827_4850 = state_4812__$1;
(statearr_4827_4850[(1)] = (8));

} else {
var statearr_4828_4851 = state_4812__$1;
(statearr_4828_4851[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (14))){
var inst_4805 = (state_4812[(2)]);
var inst_4806 = cljs.core.async.close_BANG_.call(null,out);
var state_4812__$1 = (function (){var statearr_4830 = state_4812;
(statearr_4830[(13)] = inst_4805);

return statearr_4830;
})();
var statearr_4831_4852 = state_4812__$1;
(statearr_4831_4852[(2)] = inst_4806);

(statearr_4831_4852[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (10))){
var inst_4795 = (state_4812[(2)]);
var state_4812__$1 = state_4812;
var statearr_4832_4853 = state_4812__$1;
(statearr_4832_4853[(2)] = inst_4795);

(statearr_4832_4853[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4813 === (8))){
var inst_4772 = (state_4812[(8)]);
var inst_4776 = (state_4812[(9)]);
var inst_4780 = (state_4812[(10)]);
var inst_4785 = inst_4772.push(inst_4776);
var tmp4829 = inst_4772;
var inst_4772__$1 = tmp4829;
var inst_4773 = inst_4780;
var state_4812__$1 = (function (){var statearr_4833 = state_4812;
(statearr_4833[(7)] = inst_4773);

(statearr_4833[(14)] = inst_4785);

(statearr_4833[(8)] = inst_4772__$1);

return statearr_4833;
})();
var statearr_4834_4854 = state_4812__$1;
(statearr_4834_4854[(2)] = null);

(statearr_4834_4854[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__2937__auto___4840,out))
;
return ((function (switch__2842__auto__,c__2937__auto___4840,out){
return (function() {
var cljs$core$async$state_machine__2843__auto__ = null;
var cljs$core$async$state_machine__2843__auto____0 = (function (){
var statearr_4835 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4835[(0)] = cljs$core$async$state_machine__2843__auto__);

(statearr_4835[(1)] = (1));

return statearr_4835;
});
var cljs$core$async$state_machine__2843__auto____1 = (function (state_4812){
while(true){
var ret_value__2844__auto__ = (function (){try{while(true){
var result__2845__auto__ = switch__2842__auto__.call(null,state_4812);
if(cljs.core.keyword_identical_QMARK_.call(null,result__2845__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2845__auto__;
}
break;
}
}catch (e4836){if((e4836 instanceof Object)){
var ex__2846__auto__ = e4836;
var statearr_4837_4855 = state_4812;
(statearr_4837_4855[(5)] = ex__2846__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4812);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4836;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__2844__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4856 = state_4812;
state_4812 = G__4856;
continue;
} else {
return ret_value__2844__auto__;
}
break;
}
});
cljs$core$async$state_machine__2843__auto__ = function(state_4812){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__2843__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__2843__auto____1.call(this,state_4812);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__2843__auto____0;
cljs$core$async$state_machine__2843__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__2843__auto____1;
return cljs$core$async$state_machine__2843__auto__;
})()
;})(switch__2842__auto__,c__2937__auto___4840,out))
})();
var state__2939__auto__ = (function (){var statearr_4838 = f__2938__auto__.call(null);
(statearr_4838[(6)] = c__2937__auto___4840);

return statearr_4838;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__2939__auto__);
});})(c__2937__auto___4840,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;


//# sourceMappingURL=async.js.map
